TITLE           EDIPATCH
; EDITORE DI PATCHS PER D 50 ROLAND
; INTERFACCIA USATA ROLAND MPU IPC T
 
;
;EQUATES
;
 
;MIDI I/O
STATPORT        EQU     331H
COMPORT         EQU     331H
DATAPORT        EQU     330H
DRS             EQU     80H
DRR             EQU     40H
ACK             EQU     0FEH
DT1             EQU     12H
RQ1             EQU     11H
WANTSEND        EQU     0DFH
SYSINI          EQU     0FFH
EXCLUINI        EQU     0F0H
ROLAND          EQU     41H
D50             EQU     14H
ENDEXCLU        EQU     0F7H
RESETTA         EQU     0FFH
RICEVIEXCLU     EQU     97H
 
;ATTRIBUTI  CARATTERI
ATTSCRITTE      EQU       7H     ;BIANCO
ATTNERO         EQU       0H     ;NERO
ATTFONDO        EQU      10H     ;BLU
ATTMESSG        EQU      20H     ;VERDE
ATTETICHNO      EQU      50H     ;MAGENTA
ATTETICHSI      EQU      57H     ;MAGENTA E BIANCO
ATTDATONO       EQU      60H     ;MARRONE
ATTDATOSI       EQU      67H     ;MARRONE E BIANCO
ATTBOTTNO       EQU      30H     ;CIAN
ATTBOTTSI       EQU      40H     ;ROSSO
 
;FRECCIE IL PRIMO CARATTERE LETTO 0, IL SECONDO CORRISPONDE A:
ARROWSU         EQU     'H'
ARROWGIU        EQU     'P'
ARROWDS         EQU     'M'
ARROWSN         EQU     'K'
ARROWPGIND      EQU     'I'
ARROWPGAV       EQU     'Q'
ARROWHOME       EQU     'G'
ARROWEND        EQU     'O'
 
DSEG            SEGMENT PARA PUBLIC 'DATA'
 
;INTERRUPT VECCHIO
OLD24BX         DW   0H
OLD24ES         DW   0H
 
;MESSAGGI
;MESSGn  DB ' ........  $'
INCLUDE  MESSAGGI
 
;BYTE DI STATUS DEI PROCESSI CORRENTI
;0 = PROCESSO NON IN ESECUZIONE, 1,2,... STATI AVANZAMENTO VARI 0FFH=FINE
STATUSTA        DB      00H
STATUSTR        DB      00H
STATUSRC        DB      00H
STATUSSP        DB      00H
STATUSFI        DB      00H
STATUSCO        DB      00H
 
;WORD CON INDIRIZZO ROUTINES CORRENTI;
PUBLIC  ROUTINETA,ROUTINETR,ROUTINERC,ROUTINESP,ROUTINEFI,ROUTINECO
ROUTINETA       DW      00H
ROUTINETR       DW      00H
ROUTINERC       DW      00H
ROUTINESP       DW      00H
ROUTINEFI       DW      00H
ROUTINECO       DW      01H
 
;TABELLA INDIRIZZI DELLE ROUTINES POSSIBILI, NUMERATE DA 1 A 256
;SONO INIZIALIZZATE DAL MAIN
ROUTINE         DD      256     DUP(?)
TIMESP          DW      0              ;CONTEGGIO CICLI PER TIMEOUT
TIMECO          DW      0              ;CONTEGGIO CICLI PER TIMEOUT
ERRORSP         DB      0              ; =1 SE ERRORE INIZIALIZZAZIONE MPU
 
;VARIABILI USATE PER INTERFACCIA MIDI
COMBFR          DB      00H            ;COMANDI DA METTERE IN COMPORT
ACKNOWLEDGE     DB      00H            ;0=ATTESA CONFERMA  1=ACK ARRIVATO
PTRDATICOM      DW      0000H          ;DATI IN TRASMISSIONE
BDATICOM        DB      512 DUP(0FFH)
NDATICOM        DW      0
PTRDATIIN       DW      0000H          ;DATI IN RICEZIONE
BDATIIN         DB      512 DUP(0FFH)
NDATIIN         DW      0
RICHIESTA1      DB      0F0H,41H,0H,14H,11H,0,0,00H,0,0,40H,40H,0F7H
RICHIESTA2      DB      0F0H,41H,0H,14H,11H,0,0,40H,0,0,40H,00H,0F7H
RICHIESTA3      DB      0F0H,41H,0H,14H,11H,0,1,00H,0,0,40H,3FH,0F7H
RICHIESTA4      DB      0F0H,41H,0H,14H,11H,0,1,40H,0,0,40H,7FH,0F7H
RICHIESTA5      DB      0F0H,41H,0H,14H,11H,0,2,00H,0,0,40H,3EH,0F7H
RICHIESTA6      DB      0F0H,41H,0H,14H,11H,0,2,40H,0,0,40H,7EH,0F7H
RICHIESTA7      DB      0F0H,41H,0H,14H,11H,0,3,00H,0,0,40H,3DH,0F7H
CAPPELLO        DB      0F0H,41H,0H,14H,12H
OPZIONEUPLO     DB      1               ;1=UPPER+LOWER, 2=UPPER, 3=LOWER
OPZIONEXX       DB      1               ;OPZIONE CONGELATA DURANTE READ
 
;VARIABILI USATE PER I FILES
NOMEFILE        DB 'NEWPATCH',24 DUP(0);NOME FILE
FHANDLE         DW      00H             ;FILE HANDLE DEL FILE APERTO
NOMEFILE2       DB  30 DUP(0)           ;SECONDO FILE
 
;REGISTRI ROLAND D 50
ADDRESS1        DB      00H
ADDRESS2        DB      00H
ADDRESS3        DB      00H
PARITY          DB      00H
 
;DATI TONI   IN OGNI BLOCCO 64 DATI + PARITA
;PATCH  CONTIENE IL CAMPO MEMO DAL BYTE 66 IN POI
ADDUPARZ1       DB  00H,00H,00H
UPARZ1          DB  77 DUP(0H)
ADDUPARZ2       DB  00H,00H,40H
UPARZ2          DB  77 DUP(0H)
ADDUCOMMON      DB  00H,01H,00H
UCOMMON         DB  77 DUP(0H)
ADDLPARZ1       DB  00H,01H,40H
LPARZ1          DB  77 DUP(0H)
ADDLPARZ2       DB  00H,02H,00H
LPARZ2          DB  77 DUP(0H)
ADDLCOMMON      DB  00H,02H,40H
LCOMMON         DB  77 DUP(0H)
ADDPATCH        DB  00H,03H,00H
PATCH           DB  78 DUP(0H)
 
TONI2           DB  561 DUP(0H)       ;BUFFER SECONDO FILE
 
;VARIABILI PER EDITING
OFFETICH        DW     0        ;OFFSET INDIRIZZO ETICHETTE IN USO
OFFVAR          DW     0        ;                 VARIABILI
OFFTIPOVAR      DW     0        ;
OFFMAXVAL       DW     0        ;OFFSET INDIRIZZO MAXVAL IN USO
ETICHX          DB     2        ;X ETICHETTA
ETICHY          DB     10       ;Y ETICHETTA
ETICHN          DB     0        ;N VARIABILE
ETICHADDR1      DW     1202     ;(80(Y-1)+(X-1))      0..1999
ETICHADDR2      DW     1202     ;(80(Y-1)+(X-1))*2    0..3999
ATTDATI         DB      60H     ;ATTRIBUTO DATO SI O NO
ATTETICH        DB      50H     ;ATTRIBUTO ETICHETTA SI O NO
AUTO            DB      0H      ;AUTO=0 NO AUTOWRITE  =1 AUTOWRITE ON
 
INCLUDE         DATI
; DATI CONTIENE I SEGUENTI DATI PER EDITING PARAMETRI
;ETICHETTE
;ETICHPARZ       DB  (64*14) DUP(?)
;ETICHCOMM       DB  (64*14) DUP(?)
;ETICHPATCH      DB  (64*14) DUP(?)
;
;VALORI MASSIMI VARIABILI
;MAXVALPARZ      DB   64 DUP (?)
;MAXVALCOMM      DB   64 DUP (?)
;MAXVALPATCH     DB   64 DUP (?)
;
;TIPI DELLE VARIABILI
;TIPO 0=NON USATA, 1 NUMERICA DA 0 A 256, 2 NUMERICA DA -50 A +50
;
;TIPOVARPARZ     DB   64 DUP(?)
;TIPOVARCOMM     DB   64 DUP(?)
;TIPOVARPATCH    DB   64 DUP(?)
;
;TIPOVAR1        DB   (256*4) DUP(?)
;TIPOVAR2        DB   ..............
;...................................
;TIPOVAR35       DB   ..............
 
ADDRTIPOVAR      DW   64 DUP(0)        ; CONTIENE GLI OFFSET DI TIPOVARXX
 
; da 0 a 63 tutte le lettere per i nomi paths e toni
ALFABETO         DB   ' ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890-'
                 DB   ' ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890-'
 
;DATA BASE DEI BOTTONI
;COLONNA X, RIGA Y, LUNGHEZZA,
NBOTTONI        DB   24
BOTTONI         DB 2,2,4,0      ;1=QUIT          =193=
                DB 12,2,4,0     ;2=READ D50      =194=
                DB 17,2,4,0     ;3=READ FILE     =195=
                DB 28,2,4,0     ;4=WRITE D50     =196=
                DB 33,2,4,0     ;5=WRITE FILE    =197=
                DB 38,2,5,0     ;6=PRINT
                DB 44,2,6,0     ;7=ASSEGNA NOME FILE =199=
                DB 8,4,5 ,0     ;8=PATCH         =200=
                DB 15,4,5,0     ;9=UCOMM         =201=
                DB 22,4,5,0     ;10=UPAR1        =202=
                DB 29,4,5,0     ;11=UPAR2        =203=
                DB 36,4,5,0     ;12=LCOMM        =204=
                DB 43,4,5,0     ;13=LPAR1        =205=
                DB 50,4,5,0     ;14=LPAR2        =206=
                DB 70,4,3,0     ;15=U+L          =207=
                DB 75,4,1,0     ;16=U            =208=
                DB 78,4,1,0     ;17=L            =209=
                DB 2,6,8 ,0     ;18=MESSAGE
                DB 73,6,2,0     ;19=AUTOWR ON    =211=
                DB 77,6,3,0     ;20=AUTOWR OFF   =212=
                DB 2,8,6,0      ;21=PATCH
                DB 28,8,6,0     ;22=UPPER
                DB 46,8,6,0     ;23=LOWER
                DB 64,8,5,0     ;24=MEMO
                DB 20 DUP(1)    ;SPAZIO ALTRI BOTTONI
LASTBOTTON      DB 0            ;ULTIMO BOTTONE ATTIVATO
                                ;OGNI ROUTINE BOTTONE QUANDO ESCE SCRIVE QUI
                                ;SERVE PER LE CONFERME
 
;CAMPI SPECIALI   X,Y,LUNGHEZZA,INDIRIZZO ATTRIBUTI
;PER MESSAGGIO, NOME FILE, NOME PATCH, NOME UPPER, NOME LOWER, MEMO
MESSGX          DB      10
MESSGY          DB       6
MESSGLEN        DW      50
MESSGADDR       DW      818    ;(80*(MESSGY-1) + (MESSGX-1) )*2
FILEX           DB      50
FILEY           DB      2
FILELEN         DW      29
FILEADDR        DW      258
PATCHX          DB      8
PATCHY          DB      8
PATCHLEN        DW      18
PATCHADDR       DW      1134
UPPERX          DB      34
UPPERY          DB      8
UPPERLEN        DW      10
UPPERADDR       DW      1186
LOWERX          DB      52
LOWERY          DB      8
LOWERLEN        DW      10
LOWERADDR       DW      1222
MEMOX           DB      69
MEMOY           DB      8
MEMOLEN         DW      11
MEMOADDR        DW      1256
 
;DATI SCHERMO
ADDSCHERMO      DW  0B800H     ;BASE INDIRIZZO PAGINA 0 VIDEO
 
;FILE CON LA VARIABILE       SCHERMATA
INCLUDE         INITSCR                 ;SCHERMATA INIZIALE
;SCHERMATA       DB  2000 DUP(?)
 
STATOSCHERMO    DB  2000 DUP(0)      ;BOTTONI, CAMPI DA EDIRTARE ...
                                     ;1 SU STATOSCHERMO = VARIABILE 0
 
;DATI CURSORE
CURSX           DB   0  ;DA 1 A 80   COLONNA
CURSY           DB   0  ;DA 1 A 25   RIGA
CURADDRESS      DW   0  ;OFFSET DELL'ATTRIBUTO CURSORE
STATOCURSORE    DB   0  ;N. DEL DATO O DEL BOTTONE SU CUI CI SI TROVA
ATTCURSORE      DB   0  ;ATTRIBUTO PRECEDENTE ALLA POSIZIONE DEL CURSORE
NEWCURSX        DB   0  ;
NEWCURSY        DB   0  ;
NEWSTCRS        DB   0  ;
 
DSEG            ENDS
 
CSEG            SEGMENT PARA PUBLIC 'CODE'
                ASSUME CS:CSEG, SS:STACK, DS:DSEG, ES:DSEG
;
;PROCEDURE DI SERVIZIO CHIAMATE DALLE ALTRE PROCEDURE PRINCIPALI
;
 
 
;CALCOLA DA ETICHX E ETICHY ETICHADDR1=(80(Y-1)+(X-1) E ETICHADDR2=2*1
ETICHXYADDR     PROC    FAR
                PUSH    AX
                PUSH    BX
                MOV     BL,ETICHX       ; X E Y IN BL, BH
                MOV     BH,ETICHY       ; X E Y IN BL, BH
                MOV     AX,80           ; CALCOLA  80(Y-1)+(X-1)
                SUB     BX,101H         ; X=1  Y=1   CORRISPONDE A 0
                MUL     BH
                MOV     BH,0
                ADD     AX,BX           ; IL RISULTATO E' AX
                MOV     ETICHADDR1,AX    ;
                SAL     AX,1
                MOV     ETICHADDR2,AX    ;
                POP     BX
                POP     AX
                RET
ETICHXYADDR     ENDP
 
;MOSTRA IL DATO DI UNA VARIABILE    LUNGHEZZA SCRITTA 5
;DA ETICHX, ETICHY, ETICHADDR2, ETICHN
;LE COORDINATE X E Y, GLI INDIRIZZI PER SCHERMO E IL NUMERO DELLA VARIABILE
;OFFVAR    OFFSET VARIABILI IN USO: OFFSET DI UPARZ1, UPARZ2,...
;OFFTIPOVAR   OFFSET DEL TIPO VARIABILE IN USO: OFFSET DI TIPOVARPARZ,TIPOVARCOMM,TIPOVARPATCH
;OFFMAXVAL OFFSET DEI MAXVALPARZ, MAXVALCOMM,MAXVALPATCH
;ADDRTIPOVAR    OFFSET DI TIPOVAR1,TIPOVAR2,....
SHOW1VAR        PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    SI
                PUSH    DI
                PUSH    ES
                MOV     AX,ADDSCHERMO
                MOV     ES,AX              ;ES PUNTA AL VIDEO
                MOV     AL,ETICHN
                MOV     AH,0
                ADD     AX,OFFVAR
                MOV     SI,AX
                MOV     BL,DS:[SI]         ;BL VALORE VARIABILE
                MOV     AH,0
                MOV     AL,ETICHN
                ADD     AX,OFFMAXVAL
                MOV     SI,AX
                MOV     BH,DS:[SI]         ;BH MAX VALORE AMMESSO
                CMP     BH,BL
                JAE     SH1VARBEN
                MOV     BL,BH              ;METTE IL MASSIMO VALORE
                MOV     BH,0
                SAR     BX,1
SH1VARBEN:      MOV     AH,0
                MOV     AL,ETICHN
                ADD     AX,OFFTIPOVAR
                MOV     SI,AX
                MOV     AL,DS:[SI]   ;AL NUMERO DEL TIPO VARIABILE
                DEC     AL
                MOV     AH,0
                SAL     AX,1
                MOV     SI,AX
                MOV     DI,DS:ADDRTIPOVAR[SI]  ;DI INDIRIZZO DEL TIPO VAR
                MOV     AX,5
                MUL     BL
                ADD     DI,AX              ;DI PRONTO
                MOV     SI,ETICHADDR2      ;SI PRONTO
                MOV     AH,ATTDATONO
                MOV     CX,5
SH1VARLOOP:     MOV     AL,DS:[DI]
                MOV     ES:[SI],AX
                INC     SI
                INC     SI
                INC     DI
                LOOP    SH1VARLOOP
                POP     ES
                POP     DI
                POP     SI
                POP     CX
                POP     BX
                POP     AX
                RET
SHOW1VAR        ENDP
 
;MOSTRA ETICHETTA RELATIVA ALLA VARIABILE ETICHN NELLA POSIZIONE
;ETICHX,ETICHY
SHOW1ETICH      PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    BP
                PUSH    SI
                PUSH    DI
                PUSH    ES
                MOV     AX,ADDSCHERMO
                MOV     ES,AX                  ;ES PUNTA AL VIDEO
                CALL    ETICHXYADDR            ;CALCOLATO ETICHADDR
                MOV     AX,13
                MOV     BL,ETICHN
                MUL     BL
                ADD     AX,OFFETICH
                MOV     BP,AX           ;BP=OFFETICH+13*ETICHN
                MOV     SI,0
                MOV     DI,ETICHADDR2
                MOV     CX,13
                MOV     AH,ATTETICHNO
SH1ETLOOP1:     MOV     AL,DS:[BP][SI]
                MOV     ES:[DI],AX
                MOV     AL,ETICHN
                INC     AL
                PUSH    SI
                ADD     SI,ETICHADDR1
                MOV     STATOSCHERMO[SI],AL   ;1 SU STATUSCHERMO=VAR 0
                POP     SI
                INC     SI
                INC     DI
                INC     DI
                LOOP    SH1ETLOOP1
                MOV     CX,5
SH1ETLOOP2:     MOV     AL,ETICHN
                INC     AL
                PUSH    SI
                ADD     SI,ETICHADDR1
                MOV     STATOSCHERMO[SI],AL
                POP     SI
                INC     SI
                LOOP    SH1ETLOOP2
                POP     ES
                POP     DI
                POP     SI
                POP     BP
                POP     CX
                POP     BX
                POP     AX
                RET
SHOW1ETICH      ENDP
 
;PULISCE AREA EDITING   SULLO SCHERMO E SU STATOSCHERMO
PULIAREA        PROC    FAR
                PUSH    AX
                PUSH    CX
                PUSH    DI
                PUSH    ES
                MOV     CX,ADDSCHERMO
                MOV     ES,CX
                MOV     CX,1280
PULILOOP1:      MOV     DI,CX
                MOV     AL,SCHERMATA1[DI-1]
                MOV     AH,ATTFONDO+ATTSCRITTE
                SHL     DI,1
                MOV     ES:1440[DI-2],AX
                LOOP    PULILOOP1
                POP     ES
                MOV     CX,1280
                MOV     DI,720
                MOV     AL,0
PULILOOP2:      MOV     STATOSCHERMO[DI],AL
                INC     DI
                LOOP    PULILOOP2
                POP     DI
                POP     CX
                POP     AX
                RET
PULIAREA        ENDP
 
;MOSTRA TUTTE LE ETICHETTE
;LUNGHEZZA ETICHETTE 13
;COLONNE INIZIALI ETICHETTE  2,22,42,62
;RIGHE EDITORE DA 10 A 24 COMPRESE (15 RIGHE)
;OFFETICH  OFFSET DELLE ETICHETTE IN USO: OFFSET DI ETICHPARZ, ETICHCOMM,ETICHPATCH
;OFFTIPOVAR  OFFSET DEL TIPO VARIABILE IN USO: OFFSET DI TIPOVARPARZ,TIPOVARCOMM,TIPOVARPATCH
SHOWETICHALL    PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DX
                PUSH    SI
                PUSH    DI
                PUSH    BP
                CALL    PULIAREA
                MOV     ETICHX,2
                MOV     ETICHY,10
                MOV     SI,0            ;PRIMA VARIABILE
                MOV     BP,OFFTIPOVAR
SETALLLOOP:     MOV     DL,DS:[BP][SI]    ;DL=TIPO VARIABILE
                CMP     DL,0
                JE      SETALLCON    ;NIENTE ETICHETTA SE TIPOVAR=0
                MOV     AX,SI        ;VARIABILE CON ETICHETTA
                MOV     ETICHN,AL
                CALL    SHOW1ETICH
                INC     ETICHY
                CMP     ETICHY,24
                JLE     SETALLCON
                MOV     ETICHY,10
                ADD     ETICHX,20
SETALLCON:      INC     SI
                CMP     SI,63
                JLE     SETALLLOOP
                POP     BP
                POP     DI
                POP     SI
                POP     DX
                POP     CX
                POP     BX
                POP     AX
                RET
SHOWETICHALL    ENDP
 
;MOSTRA TUTTE LE VARIABILI
;LUNGHEZZA CAMPI VARIABILI 5
;COLONNE INIZIALI CAMPI VARIABILI 15,35,55,75
;RIGHE EDITORE DA 10 A 24 COMPRESE (15 RIGHE)
;USA ETICHX,ETICHY,ETICHADDR1 E 2 PER LA POSIZIONE INIZIALE DEL DATO
SHOWVARALL      PROC    FAR
                PUSH    AX
                PUSH    SI
                MOV     ETICHX,15
                MOV     ETICHY,10
SHVALLOOP:      CALL    ETICHXYADDR
                MOV     SI,ETICHADDR1
                MOV     AL,STATOSCHERMO[SI]      ;NUMERO DELLA VARIABILE
                CMP     AL,0                     ;SE 0 FINITO
                JE      SHVALLFIN
                DEC     AL                       ;TRA 0 E 63
                MOV     ETICHN,AL                ;ORA ETICHX,Y,N A POSTO
                CALL    SHOW1VAR
                INC     ETICHY
                CMP     ETICHY,24
                JLE     SHVALLOOP
                MOV     ETICHY,10
                ADD     ETICHX,20
                CMP     ETICHX,80                ;75 COMPRESO
                JLE     SHVALLOOP
SHVALLFIN:      POP     SI
                POP     AX
                RET
SHOWVARALL      ENDP
 
;NUOVO INTERRUPT PER GLI ERRORI CRITICI
;IN CASO DI ERRORE DI DISCO PONE STATUSFI=0EEH
NEW24           PROC    FAR
                POP     BX ;       IP
                POP     CX ;       CS
                POP     DX ;       FLAGS
                ROL     AH,1
                JNC     ERRDISCO
                MOV     AL,2      ;BREAK
                PUSH    DX
                PUSH    CX
                PUSH    BX
                IRET              ;LA PALLA AL DOS
ERRDISCO:       POP     AX
                POP     BX
                POP     CX
                POP     DX
                POP     SI
                POP     DI
                POP     BP
                POP     DS
                POP     ES
                MOV     STATUSFI,0EEH
                IRET              ;A DOPO LA LA CHIAMATA INT21
                POP AX ;SCARTA IP
                POP AX ;SCARTA CS
                POP AX ;SCARTA FLAGS
NEW24           ENDP
 
 
;INIZIALIZZAZIONE NUOVO INTERRUPT NEW24
INITINT         PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    ES
                MOV     AL,24H
                MOV     AH,35H
                INT     21H
                MOV     OLD24ES,ES
                MOV     OLD24BX,BX
                PUSH    DS
                MOV     AX,SEG      NEW24
                MOV     DS,AX
                MOV     DX,OFFSET   NEW24
                MOV     AL,24H
                MOV     AH,25H
                INT     21H
                POP     DS
                POP     ES
                POP     BX
                POP     AX
                RET
INITINT         ENDP
 
;PROCEDURA CHE STAMPA MESSAGGIO DI OFFSET IN DX
;RIGA 6 COLONNA 10 LUNGHEZZA  50 ATTRIBUT0 ATTMESSG
MESSAGGIO       PROC       FAR
                PUSH    AX
                PUSH    CX
                PUSH    SI
                PUSH    DI
                PUSH    ES
                MOV     SI,DX
                MOV     CX,ADDSCHERMO
                MOV     ES,CX
                MOV     CX,MESSGLEN
                MOV     AH,ATTMESSG
                MOV     DI,MESSGADDR   ;(5*80+9)*2
MMLOOP1:        MOV     AL,DS:[SI]
                MOV     ES:[DI],AX
                INC     SI
                INC     DI
                INC     DI
                LOOP    MMLOOP1
                POP     ES
                POP     DI
                POP     SI
                POP     CX
                POP     AX
                RET
MESSAGGIO       ENDP
 
;MOSTRA IL NOMEFILE  NEL CAMPO DEL FILE
;IL NOME FILE E' UNA STINGA ASCIIZ, TERMINATA DA 00, DI NON PIU
;DI 29 CARATTERI ; LA POSIZIONE OVE DA FILEX,FILEY,FILEADDR,FILELEN
MOSTRAFILE      PROC    FAR
                PUSH    AX
                PUSH    CX
                PUSH    SI
                PUSH    DI
                PUSH    ES
                MOV     SI,OFFSET NOMEFILE
                MOV     CX,ADDSCHERMO
                MOV     ES,CX
                MOV     CX,FILELEN
                MOV     AH,ATTMESSG
                MOV     DI,FILEADDR
MOFILELOOP:     MOV     AL,DS:[SI]
                CMP     AL,0
                JE      MOFILE1
                MOV     ES:[DI],AX
                INC     SI
                INC     DI
                INC     DI
                LOOP    MOFILELOOP
                JMP     MOFILEEND
MOFILE1:        MOV     AH,ATTFONDO+ATTSCRITTE  ;DALLO 0 IN POI
                MOV     AL,0
                MOV     DS:[SI],AL
                MOV     AL,' '
                MOV     ES:[DI],AX
                INC     SI
                INC     DI
                INC     DI
                LOOP    MOFILE1
MOFILEEND:      POP     ES
                POP     DI
                POP     SI
                POP     CX
                POP     AX
                RET
MOSTRAFILE      ENDP
 
;MOSTRA IL NOME PATCH NEL CAMPO DEL PATCHNAME
;IL NOME PATCH E' UNA STRINGA DI 18 CARATTERI CODIFICATI CON ALFABETO
MOSTRAPATCH     PROC    FAR
                PUSH    AX
                PUSH    CX
                PUSH    SI
                PUSH    DI
                PUSH    ES
                MOV     SI,OFFSET PATCH
                MOV     CX,ADDSCHERMO
                MOV     ES,CX
                MOV     CX,18
                MOV     AH,ATTMESSG
                MOV     DI,PATCHADDR
MOPATCHLOOP:    MOV     AL,DS:[SI]
                PUSH    SI
                MOV     SI,AX
                AND     SI,007FH
                MOV     AL,ALFABETO[SI]
                POP     SI
                MOV     ES:[DI],AX
                INC     SI
                INC     DI
                INC     DI
                LOOP    MOPATCHLOOP
                POP     ES
                POP     DI
                POP     SI
                POP     CX
                POP     AX
                RET
MOSTRAPATCH     ENDP
 
;MOSTRA IL NOME UPPER NEL CAMPO DEL UPPER TONE
;IL NOME PATCH E' UNA STRINGA DI 10 CARATTERI CODIFICATI CON ALFABETO
MOSTRAUPPER     PROC    FAR
                PUSH    AX
                PUSH    CX
                PUSH    SI
                PUSH    DI
                PUSH    ES
                MOV     SI,OFFSET UCOMMON
                MOV     CX,ADDSCHERMO
                MOV     ES,CX
                MOV     CX,10
                MOV     AH,ATTMESSG
                MOV     DI,UPPERADDR
MOUPPERLOOP:    MOV     AL,DS:[SI]
                PUSH    SI
                MOV     SI,AX
                AND     SI,00FFH
                MOV     AL,ALFABETO[SI]
                POP     SI
                MOV     ES:[DI],AX
                INC     SI
                INC     DI
                INC     DI
                LOOP    MOUPPERLOOP
                POP     ES
                POP     DI
                POP     SI
                POP     CX
                POP     AX
                RET
MOSTRAUPPER     ENDP
 
;MOSTRA IL NOME LOWER NEL CAMPO DEL UPPER TONE
;IL NOME PATCH E' UNA STRINGA DI 10 CARATTERI CODIFICATI CON ALFABETO
MOSTRALOWER     PROC    FAR
                PUSH    AX
                PUSH    CX
                PUSH    SI
                PUSH    DI
                PUSH    ES
                MOV     SI,OFFSET LCOMMON
                MOV     CX,ADDSCHERMO
                MOV     ES,CX
                MOV     CX,10
                MOV     AH,ATTMESSG
                MOV     DI,LOWERADDR
MOLOWERLOOP:    MOV     AL,DS:[SI]
                PUSH    SI
                MOV     SI,AX
                AND     SI,00FFH
                MOV     AL,ALFABETO[SI]
                POP     SI
                MOV     ES:[DI],AX
                INC     SI
                INC     DI
                INC     DI
                LOOP    MOLOWERLOOP
                POP     ES
                POP     DI
                POP     SI
                POP     CX
                POP     AX
                RET
MOSTRALOWER     ENDP
 
 
;CALCOLA PARITA DI UN BLOCCO DI 3+64 BYTES
;CON OFFSET IN BX
PARIT           PROC    FAR
                PUSH    AX
                PUSH    DX
                PUSH    SI
                XOR     AX,AX
                XOR     SI,SI
                CLC
PALOOP:         MOV     DL,[BX][SI]
                ADD     AL,DL
                INC     SI
                CMP     SI,67
                JL      PALOOP
                NEG     AL
                MOV     [BX]+67,AL
                POP     SI
                POP     DX
                POP     AX
                RET
PARIT           ENDP
 
;CANCELLA CURSORE RIMETTENDO A POSTO VECCHIO ATTRIBUTO
;TUTTE LE OPERAZIONI GRAFICHE VANNO EFFETTUATE CON CURSORE CANCELLATO
DELCURS         PROC    FAR
                PUSH    ES
                PUSH    AX
                PUSH    DI
                MOV     AX,ADDSCHERMO
                MOV     ES,AX
                MOV     AX,CURADDRESS
                MOV     DI,AX
                MOV     AL,ATTCURSORE
                MOV     ES:[DI],AL
                POP     DI
                POP     AX
                POP     ES
                RET
DELCURS         ENDP
 
;CURSORE VISIBILE INVERTENDO FONDO CON COLORE
SHOWCURS        PROC    FAR
                PUSH    ES
                PUSH    AX
                PUSH    DI
                MOV     AX,ADDSCHERMO
                MOV     ES,AX
                MOV     AX,CURADDRESS
                MOV     DI,AX
                MOV     AL,ES:[DI]       ;0XXX0YYY BIT
                MOV     ATTCURSORE,AL
                MOV     AH,AL            ;0XXX0YYY0XXX0YYY
                SHR     AX,1
                SHR     AX,1
                SHR     AX,1
                SHR     AX,1
                MOV     ES:[DI],AL
                POP     DI
                POP     AX
                POP     ES
                RET
SHOWCURS        ENDP
 
 
 
;CALCOLA X+80*Y  X IN BL, Y IN BH, RISULTATO IN AX, Y PERDUTO
CURADDR         PROC    FAR
                MOV     AX,80
                SUB     BX,101H ;   X=1  Y=1   CORRISPONDE A 0
                MUL     BH
                MOV     BH,0
                ADD     AX,BX   ;
                SHL     AX,1    ;RADDOPPIO PER PUNTARE AL CARATTERE
                INC     AX      ; AX ORA PUNTA ALL ATTRIBUTO
                RET
CURADDR         ENDP
 
; IN DH ATTBOTTSI  O  ATTBOTTNO  IN AL STATOCURSORE
;DISEGNA BOTTONE NUMERO LETTO DA AL ATTIVO O NON SECONDO DH
;193 = ESADEC 0C1H PER IL BOTTONE 1 ....
BOTTONESN       PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DI
                PUSH    ES
                MOV     AH,0
                MOV     DI,AX
                SUB     DI,0C1H         ;ORA TRA 0 E ..
                SHL     DI,1
                SHL     DI,1            ; X 4
                MOV     BL,BOTTONI[DI]  ; X E Y IN BL, BH
                MOV     BH,BOTTONI[DI+1]  ; X E Y IN BL, BH
                CALL    CURADDR         ; IN AX INDIRIZZO
                XOR     CX,CX           ;    INIZIALE BOTTONE
                MOV     CL,BOTTONI[DI+2] ;ORA CX NUMERO CARATTERI
                MOV     DI,AX
                MOV     AX,ADDSCHERMO
                MOV     ES,AX
BSNLOOP:        MOV     ES:0[DI],DH
                INC     DI
                INC     DI
                LOOP    BSNLOOP
                POP     ES
                POP     DI
                POP     CX
                POP     BX
                POP     AX
                RET
BOTTONESN       ENDP
 
;DISATTIVA BOTTONI EDITORE NON IN USO, ATTIVA QUELLO IN USO
BOTTEDITSHOW    PROC    FAR
                PUSH    AX
                CALL    DELCURS
                MOV     DH,ATTBOTTNO
                MOV     AL,200
                CALL    BOTTONESN
                MOV     DH,ATTBOTTNO
                MOV     AL,201
                CALL    BOTTONESN
                MOV     DH,ATTBOTTNO
                MOV     AL,202
                CALL    BOTTONESN
                MOV     DH,ATTBOTTNO
                MOV     AL,203
                CALL    BOTTONESN
                MOV     DH,ATTBOTTNO
                MOV     AL,204
                CALL    BOTTONESN
                MOV     DH,ATTBOTTNO
                MOV     AL,205
                CALL    BOTTONESN
                MOV     DH,ATTBOTTNO
                MOV     AL,206
                CALL    BOTTONESN
                MOV     DH,ATTBOTTSI
                MOV     AL,STATOCURSORE
                CALL    BOTTONESN
                CALL    SHOWCURS
                POP     AX
                RET
BOTTEDITSHOW    ENDP
 
;SCRIVE SU STATOSCHERMO LO STATO DI UN BOTTONE
;IN AL STATO BOTTONE; IN CX COUNT NUMBER, VANNO  SALVATI
;SERVE SOLO ALL'INIZIALIZZAZIONE FATTA DA CONTROLLO1
BOTTONEST       PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DX
                PUSH    DI
                MOV     AH,0
                MOV     DI,AX
                SUB     DI,0C1H         ;ORA TRA 0 E ..
                SHL     DI,1
                SHL     DI,1            ; X 4
                MOV     BL,BOTTONI[DI]  ; X E Y IN BL, BH
                MOV     BH,BOTTONI[DI+1]  ; X E Y IN BL, BH
                MOV     DL,AL
                MOV     AX,80             ;CALCOLA OFFSET 80(Y-1)+(X-1)
                SUB     BX,101H ;   X=1  Y=1   CORRISPONDE A 0
                MUL     BH
                MOV     BH,0
                ADD     AX,BX   ;
                XOR     CX,CX           ;    INIZIALE BOTTONE
                MOV     CL,BOTTONI[DI+2] ;ORA CX NUMERO CARATTERI
                MOV     DI,AX
BSTLOOP:        MOV     STATOSCHERMO[DI],DL
                INC     DI
                LOOP    BSTLOOP
                POP     DI
                POP     DX
                POP     CX
                POP     BX
                POP     AX
                RET
BOTTONEST       ENDP
 
;LEGGE OPZIONEUPLO E DISEGANA CORRISPONEDNTEMETE I 3 BOTTONI U+L, U, L
OPZIONEUL       PROC    FAR
                PUSH    AX
                PUSH    DX
                CALL    DELCURS
                MOV     DH,ATTBOTTSI
                CMP     OPZIONEUPLO,1
                JE      OUL1
                MOV     DH,ATTBOTTNO
OUL1:           MOV     AL,207          ;U+L
                CALL    BOTTONESN
                CALL    SHOWCURS
                CALL    DELCURS
                MOV     DH,ATTBOTTSI
                CMP     OPZIONEUPLO,2
                JE      OUL2
                MOV     DH,ATTBOTTNO
OUL2:           MOV     AL,208          ;U
                CALL    BOTTONESN
                CALL    SHOWCURS
                CALL    DELCURS
                MOV     DH,ATTBOTTSI
                CMP     OPZIONEUPLO,3
                JE      OUL3
                MOV     DH,ATTBOTTNO
OUL3:           MOV     AL,209          ;L
                CALL    BOTTONESN
                CALL    SHOWCURS
                POP     DX
                POP     AX
                RET
OPZIONEUL       ENDP
 
;PREPARA DATI PER TRASMISSIONE  BLOCCO IN AL
WWSEND          PROC    FAR
                PUSH    SI
                PUSH    DI
                PUSH    CX
                PUSH    AX
                MOV     STATUSTR,0      ;ABILITA TRASMISSIONE
                MOV     PTRDATICOM,0
                MOV     NDATICOM,74   ;5CAPPELLO+64DATI+3ADDR+1PARITY+1EOE
                PUSH    AX              ;SALVA AL
                MOV     CX,5
                MOV     SI,0
                MOV     DI,0
WWSNDLOOP1:     MOV     AL,CAPPELLO[SI]
                MOV     DS:BDATICOM[DI],AL
                INC     SI
                INC     DI
                LOOP    WWSNDLOOP1
                POP     AX              ;COPIATO CAPPELLO
                MOV     AH,0
                MOV     CX,80           ;BLOCCO 80 DATI
                DEC     AL              ;N-1
                MUL     CL              ;80*(N-1) IN AL
                MOV     SI,AX
WWSNDLOOP2:     MOV     AL,ADDUPARZ1[SI]
                MOV     DS:BDATICOM[DI],AL
                INC     SI
                INC     DI
                LOOP    WWSNDLOOP2
                MOV     BX,OFFSET BDATICOM
                ADD     BX,5
                CALL    PARIT
                MOV     BDATICOM[73],ENDEXCLU
                POP     AX
                POP     CX
                POP     DI
                POP     SI
                RET
WWSEND          ENDP
 
;PREPARA DATI RICHIESTA BLOCCO AL
DRQST           PROC    FAR
                PUSH    SI
                PUSH    DI
                PUSH    CX
                PUSH    AX
                MOV     STATUSTR,0
                MOV     PTRDATICOM,0
                MOV     NDATICOM,13
                MOV     AH,0
                MOV     CX,13
                DEC     AL              ;N-1
                MUL     CL              ;13*(N-1) IN AL
                MOV     SI,AX
                MOV     DI,0
DRQSTLOOP:      MOV     AL,RICHIESTA1[SI]
                MOV     DS:BDATICOM[DI],AL
                INC     SI
                INC     DI
                LOOP    DRQSTLOOP
                POP     AX
                POP     CX
                POP     DI
                POP     SI
                RET
DRQST           ENDP
 
;LIBERA BUFFER DA BLOCCO1
LLIBB1          PROC    FAR
                PUSH    SI
                PUSH    DI
                PUSH    CX
                PUSH    AX
                MOV     CX,NDATIIN
                MOV     SI,0
                MOV     DI,0
LLIBB1LOOP:     MOV     AL,BDATIIN[SI]
                MOV     DS:ADDUPARZ1[DI],AL
                INC     SI
                INC     DI
                LOOP    LLIBB1LOOP
                MOV     NDATIIN,0
                MOV     PTRDATIIN,0
                MOV     STATUSRC,0
                POP     AX
                POP     CX
                POP     DI
                POP     SI
                RET
LLIBB1          ENDP
 
;LIBERA BUFFER DA BLOCCO2
LLIBB2          PROC    FAR
                PUSH    SI
                PUSH    DI
                PUSH    CX
                PUSH    AX
                MOV     CX,NDATIIN
                MOV     SI,0
                MOV     DI,0
LLIBB2LOOP:     MOV     AL,BDATIIN[SI]
                MOV     DS:ADDUPARZ2[DI],AL
                INC     SI
                INC     DI
                LOOP    LLIBB2LOOP
                MOV     NDATIIN,0
                MOV     PTRDATIIN,0
                MOV     STATUSRC,0
                POP     AX
                POP     CX
                POP     DI
                POP     SI
                RET
LLIBB2          ENDP
 
;LIBERA BUFFER DA BLOCCO3
LLIBB3          PROC    FAR
                PUSH    SI
                PUSH    DI
                PUSH    CX
                PUSH    AX
                MOV     CX,NDATIIN
                MOV     SI,0
                MOV     DI,0
LLIBB3LOOP:     MOV     AL,BDATIIN[SI]
                MOV     DS:ADDUCOMMON[DI],AL
                INC     SI
                INC     DI
                LOOP    LLIBB3LOOP
                MOV     NDATIIN,0
                MOV     PTRDATIIN,0
                MOV     STATUSRC,0
                POP     AX
                POP     CX
                POP     DI
                POP     SI
                RET
LLIBB3          ENDP
 
;LIBERA BUFFER DA BLOCCO4
LLIBB4          PROC    FAR
                PUSH    SI
                PUSH    DI
                PUSH    CX
                PUSH    AX
                MOV     CX,NDATIIN
                MOV     SI,0
                MOV     DI,0
LLIBB4LOOP:     MOV     AL,BDATIIN[SI]
                MOV     DS:ADDLPARZ1[DI],AL
                INC     SI
                INC     DI
                LOOP    LLIBB4LOOP
                MOV     NDATIIN,0
                MOV     PTRDATIIN,0
                MOV     STATUSRC,0
                POP     AX
                POP     CX
                POP     DI
                POP     SI
                RET
LLIBB4          ENDP
 
;LIBERA BUFFER DA BLOCCO5
LLIBB5          PROC    FAR
                PUSH    SI
                PUSH    DI
                PUSH    CX
                PUSH    AX
                MOV     CX,NDATIIN
                MOV     SI,0
                MOV     DI,0
LLIBB5LOOP:     MOV     AL,BDATIIN[SI]
                MOV     DS:ADDLPARZ2[DI],AL
                INC     SI
                INC     DI
                LOOP    LLIBB5LOOP
                MOV     NDATIIN,0
                MOV     PTRDATIIN,0
                MOV     STATUSRC,0
                POP     AX
                POP     CX
                POP     DI
                POP     SI
                RET
LLIBB5          ENDP
 
;LIBERA BUFFER DA BLOCCO6
LLIBB6          PROC    FAR
                PUSH    SI
                PUSH    DI
                PUSH    CX
                PUSH    AX
                MOV     CX,NDATIIN
                MOV     SI,0
                MOV     DI,0
LLIBB6LOOP:     MOV     AL,BDATIIN[SI]
                MOV     DS:ADDLCOMMON[DI],AL
                INC     SI
                INC     DI
                LOOP    LLIBB6LOOP
                MOV     NDATIIN,0
                MOV     PTRDATIIN,0
                MOV     STATUSRC,0
                POP     AX
                POP     CX
                POP     DI
                POP     SI
                RET
LLIBB6          ENDP
 
;LIBERA BUFFER DA BLOCCO7
LLIBB7          PROC    FAR
                PUSH    SI
                PUSH    DI
                PUSH    CX
                PUSH    AX
                MOV     CX,NDATIIN
                MOV     SI,0
                MOV     DI,0
LLIBB7LOOP:     MOV     AL,BDATIIN[SI]
                MOV     DS:ADDPATCH[DI],AL
                INC     SI
                INC     DI
                LOOP    LLIBB7LOOP
                MOV     NDATIIN,0
                MOV     PTRDATIIN,0
                MOV     STATUSRC,0
                POP     AX
                POP     CX
                POP     DI
                POP     SI
                RET
LLIBB7          ENDP
 
;AGGIORNA I DATI, SE SI E' ALMENO UNA VOLTA NEL MODO EDIT
;UN PO SPORCA
AGGDATI         PROC    FAR
                CMP OFFETICH, 0
                JE  NOAGGDATI
                CALL SHOWVARALL
NOAGGDATI:      RET
AGGDATI         ENDP
 
;EVIDENZIA O DISEVIDENZIA ETICHETTA DI POSIZIONE ETICHX, ETICHY
;IN ATTETICH E ATTDATI ATTRIBUTI DA USARE PER ETICHETTE E DATI
EVIDETICH       PROC    FAR
                PUSH    AX
                PUSH    DI
                PUSH    CX
                PUSH    ES
                MOV     AX,ADDSCHERMO
                MOV     ES,AX
                CALL    ETICHXYADDR
                MOV     AH,ATTETICH
                MOV     DI,ETICHADDR2
                MOV     CX,13
                INC     DI
EVIDLOOP1:      MOV     ES:[DI],AH
                INC     DI
                INC     DI
                LOOP    EVIDLOOP1
                MOV     AH,ATTDATI
                MOV     CX,5
EVIDLOOP2:      MOV     ES:[DI],AH
                INC     DI
                INC     DI
                LOOP    EVIDLOOP2
                POP     ES
                POP     CX
                POP     DI
                POP     AX
                RET
EVIDETICH       ENDP
 
 
;EVIDENZIA ETICHETTA DI POSIZIONE ETICHX, ETICHY
EVIDETSI        PROC    FAR
                MOV     ATTETICH,ATTETICHSI
                MOV     ATTDATI,ATTDATOSI
                CALL    EVIDETICH
                RET
EVIDETSI        ENDP
 
;DISEVIDENZIA ETICHETTA DI POSIZIONE ETICHX, ETICHY
EVIDETNO        PROC    FAR
                MOV     ATTETICH,ATTETICHNO
                MOV     ATTDATI,ATTDATONO
                CALL    EVIDETICH
                RET
EVIDETNO        ENDP
 
;CALCOLA ETICHX E ETICHY DA CURSX E CURSY SE IN ZONA EDITORE
ETDACURS        PROC    FAR
                PUSH    AX
                MOV     AL,CURSY
                MOV     AH,CURSX
                CMP     AL,10
                JGE     ANCOR1
                POP     AX
                RET
ANCOR1:         CMP     AL,24
                JLE     ANCOR2
                POP     AX
                RET
ANCOR2:         CMP     AH,2
                JAE     ANCOR3
                POP     AX
                RET
ANCOR3:         CMP     AH,20
                JA      ANCOR4
                MOV     ETICHX,2
                MOV     ETICHY,AL
                POP     AX
                RET
ANCOR4:         CMP     AH,22
                JAE     ANCOR5
                POP     AX
                RET
ANCOR5:         CMP     AH,40
                JA      ANCOR6
                MOV     ETICHX,22
                MOV     ETICHY,AL
                POP     AX
                RET
ANCOR6:         CMP     AH,42
                JAE     ANCOR7
                POP     AX
                RET
ANCOR7:         CMP     AH,60
                JA      ANCOR8
                MOV     ETICHX,42
                MOV     ETICHY,AL
ANCOR8:         CMP     AH,62
                JAE     ANCOR9
                POP     AX
                RET
ANCOR9:         CMP     AH,80
                JA      ANCOR10
                MOV     ETICHX,62
                MOV     ETICHY,AL
ANCOR10:        POP     AX
                RET
ETDACURS        ENDP
 
;POSIZIONE VECCHIA DA CURSX,CURSY; NUOVA DA NEWCURSX, NEWCURSY
;SPOSTA IL CURSORE E AGGIORNA CURSX,CURSY,CURADDRESS,STATOCURSORE
POSIZIONA       PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    DI
                XOR     AX,AX           ;CALCOLA NUOVO STATOCURSORE
                XOR     BX,BX
                MOV     AL,NEWCURSY
                DEC     AL
                MOV     BL,80
                MUL     BL
                MOV     BL,NEWCURSX
                ADD     AX,BX
                DEC     AX
                MOV     DI,AX                   ;80*(X-1)+Y-1
                MOV     AL,STATOSCHERMO[DI]
                MOV     NEWSTCRS,AL     ;CALCOLATO NEWSTCRS
                CALL    DELCURS         ;GESTIONE EVIDENZIA ETICHETTE
                MOV     AL,STATOCURSORE
                MOV     AH,NEWSTCRS
                CMP     AL,1
                JB      POSETININO
                CMP     AL,64
                JA      POSETININO
                CMP     AH,1            ;SIAMO SU ETICHETTA
                JB      POSFUORET
                CMP     AH,64
                JA      POSFUORET       ;E ANDREMO SU ETICHETTA
                CMP     AL,AH           ;
                JE      POSIZFIN1       ;SE E LA STESSA
                CALL    ETDACURS        ;ETICHETTE DIVERSE
                CALL    EVIDETNO        ;DISATTIVA VECCHIA
                MOV     BL,NEWCURSX     ;AGGIORNA CURSX,CURSY
                MOV     BH,NEWCURSY
                MOV     CURSX,BL
                MOV     CURSY,BH
                CALL    ETDACURS
                CALL    EVIDETSI        ;ATTIVA NUOVA
                JMP     POSIZFIN2       ;AGGIORNA STATOCURSORE E CURSORE
POSETININO:     CMP     AH,1            ;INIZIALMENTE NON SU ETICH
                JB      POSIZFIN1
                CMP     AH,64
                JA      POSIZFIN1       ;MA ANDREMO SU ETICHETTA
                MOV     BL,NEWCURSX     ;AGGIORNA CURSX,CURSY
                MOV     BH,NEWCURSY
                MOV     CURSX,BL
                MOV     CURSY,BH
                CALL    ETDACURS
                CALL    EVIDETSI        ;ATTIVA ETICHETTA
                JMP     POSIZFIN2       ;AGGIORNA STATOCURSORE E CURSORE
POSFUORET:      CALL    ETDACURS
                CALL    EVIDETNO        ;DISATTIVA VECCHIA
POSIZFIN1:      MOV     BL,NEWCURSX     ;AGGIORNA CURSX,CURSY
                MOV     BH,NEWCURSY
                MOV     CURSX,BL
                MOV     CURSY,BH
POSIZFIN2:      MOV     BL,NEWSTCRS     ;AGGIORNA STATOCURSORE
                MOV     STATOCURSORE,BL
                MOV     BL,CURSX
                MOV     BH,CURSY
                CALL    CURADDR
                MOV     CURADDRESS,AX
                CALL    SHOWCURS        ;MOSTRA CURSORE
                POP     DI
                POP     BX
                POP     AX
                RET
POSIZIONA       ENDP
 
;
TASTOSU         PROC    FAR
                MOV     AL,CURSY
                CMP     AL,1
                JE      TSU1
                DEC     AL
TSU1:           MOV     NEWCURSY,AL
                MOV     AH,CURSX
                MOV     NEWCURSX,AH
                CALL    POSIZIONA
                RET
TASTOSU         ENDP
 
;
TASTOGIU        PROC    FAR
                MOV     AL,CURSY
                CMP     AL,25
                JE      TGIU1
                INC     AL
TGIU1:          MOV     NEWCURSY,AL
                MOV     AH,CURSX
                MOV     NEWCURSX,AH
                CALL    POSIZIONA
                RET
TASTOGIU        ENDP
 
;
TASTODS         PROC    FAR
                MOV     AL,CURSX
                CMP     AL,80
                JE      TDS1
                INC     AL
TDS1:           MOV     NEWCURSX,AL
                MOV     AH,CURSY
                MOV     NEWCURSY,AH
                CALL    POSIZIONA
                RET
TASTODS         ENDP
 
;
TASTOSN         PROC    FAR
                MOV     AL,CURSX
                CMP     AL,1
                JE      TSN1
                DEC     AL
TSN1:           MOV     NEWCURSX,AL
                MOV     AH,CURSY
                MOV     NEWCURSY,AH
                CALL    POSIZIONA
                RET
TASTOSN         ENDP
 
;SE AL=RETURN E SI E' SU BOTTONE, LO SI ATTIVA
SEBOTTONE       PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    DX
                CMP     AL,0DH
                JE      SEBOTT1
NONBOTT:        POP     DX
                POP     BX
                POP     AX
                RET             ;SE NON RETURN ESCI
SEBOTT1:        XOR     AX,AX
                MOV     BX,0C1H         ;DA LI IN SU BOTTONI
                MOV     AL,STATOCURSORE
                CMP     AL,BL
                JL      NONBOTT
                ADD     BL,NBOTTONI
                CMP     AL,BL
                JG      NONBOTT
                CALL    DELCURS         ;CURSORE SUL BOTTONE E RETURN
                MOV     DH,ATTBOTTSI
                MOV     AL,STATOCURSORE
                CALL    BOTTONESN
                CALL    SHOWCURS
                XOR     AX,AX           ;ATTIVA ROUTINE BOTTONE
                MOV     AL,STATOCURSORE
                CMP     AL,195
                JE      MCTASTOFILE
                CMP     AL,197
                JE      MCTASTOFILE
                MOV     ROUTINECO,AX    ;OPERAZIONI NON SU FILE
                JMP     FINBOTT
MCTASTOFILE:    MOV     ROUTINEFI,AX    ;OPERAZIONI SU FILE
FINBOTT:        POP     DX
                POP     BX
                POP     AX
                RET
SEBOTTONE       ENDP
 
;INCREMENTA DATO E LO MOSTRA SE CURSORE SU DATO
;IL CURSORE SI TROVA SU UNA ETICHETTA ETICHX,ETICHY INIZIO ETICHETTA
;SI CAMBIA TEMPORANEAMENTE ETICHX IN ETICHX+13 PER PIAZZARE DATO
INCDATO         PROC    FAR
                PUSH    DI
                PUSH    SI
                PUSH    AX
                PUSH    BX
                XOR     AX,AX
                MOV     AL,STATOCURSORE
                DEC     AX
                CMP     AL,64
                JAE     NOINCDATO       ;NON SIAMO SU UN CAMPO DATO
                MOV     ETICHN,AL
                ADD     AX,OFFVAR
                MOV     SI,AX
                MOV     BL,DS:[SI]      ;BL=VALORE VARIABILE
                MOV     AH,0
                MOV     AL,ETICHN
                ADD     AX,OFFMAXVAL
                MOV     DI,AX
                MOV     BH,DS:[DI]      ;BH=MAX VAL VARIABILE
                CMP     BH,BL
                JBE     NOINCDATO
                INC     BL
                MOV     DS:[SI],BL
                CALL    DELCURS
                XOR     AX,AX
                MOV     AL,ETICHX
                ADD     AX,13
                MOV     ETICHX,AL
                CALL    ETICHXYADDR
                CALL    SHOW1VAR
                MOV     LASTBOTTON,220  ;CONVENZIONALE
                XOR     AX,AX
                MOV     AL,ETICHX
                SUB     AX,13
                MOV     ETICHX,AL
                CALL    ETICHXYADDR
                CALL    EVIDETSI
                CALL    SHOWCURS
NOINCDATO:      POP     BX
                POP     AX
                POP     SI
                POP     DI
                RET
INCDATO         ENDP
 
;DECREMENTA DATO E LO MOSTRA
;IL CURSORE SI TROVA SU UNA ETICHETTA ETICHX,ETICHY INIZIO ETICHETTA
;SI CAMBIA TEMPORANEAMENTE ETICHX IN ETICHX+13 PER PIAZZARE DATO
DECDATO         PROC    FAR
                PUSH    SI
                PUSH    AX
                PUSH    BX
                XOR     AX,AX
                MOV     AL,STATOCURSORE
                DEC     AX
                CMP     AL,64
                JAE     NODECDATO       ;NON SIAMO SU UN CAMPO DATO
                MOV     ETICHN,AL
                ADD     AX,OFFVAR
                MOV     SI,AX
                MOV     BL,DS:[SI]      ;BL=VALORE VARIABILE
                CMP     BL,0            ;MINIMO VALORE 0
                JE      NODECDATO
                DEC     BL
                MOV     DS:[SI],BL
                CALL    DELCURS
                XOR     AX,AX
                MOV     AL,ETICHX
                ADD     AX,13
                MOV     ETICHX,AL
                CALL    ETICHXYADDR
                CALL    SHOW1VAR
                MOV     LASTBOTTON,220          ;CONVENZIONALE
                XOR     AX,AX
                MOV     AL,ETICHX
                SUB     AX,13
                MOV     ETICHX,AL
                CALL    ETICHXYADDR
                CALL    EVIDETSI
                CALL    SHOWCURS
NODECDATO:      POP     BX
                POP     AX
                POP     SI
                RET
DECDATO         ENDP
 
;EDITOR SU CAMPO DATI
EDITDATI        PROC    FAR
 
                RET
EDITDATI        ENDP
 
;PEZZO DI EDITFILE PER PRATICITA SUBROUTINE
EDFILSUB        PROC    FAR
EDFILSUB1:      MOV     AH,DS:NOMEFILE[SI+1]
                MOV     DS:NOMEFILE[SI],AH
                INC     SI
                CMP     SI,29
                JB      EDFILSUB1
                RET
EDFILSUB        ENDP
 
;EDITOR SU NOME FILE
EDITFILE        PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    SI
                XOR     BX,BX
                MOV     AH,CURSY
                CMP     AH,FILEY
                JNE     EDFILF1
                MOV     BL,CURSX
                SUB     BL,FILEX
                JL      EDFILF1
                CMP     BX,FILELEN
                JAE     EDFILF1         ;SIAMO IN ZONA FILENAME
                MOV     SI,BX
                CMP     AL,43           ;CARATTERI AMMISSIBILI
                JB      EDFIL1          ;CIFRE E ; E LETTERE
                CMP     AL,122
                JA      EDFILF1
                CMP     AL,58
                JBE     EDFIL20         ;CARATTERE NORMALE
                CMP     AL,65
                JAE     EDFIL20         ;CARATTERE NORMALE
EDFIL1:         CMP     AL,13           ;ALCUNI CARATTERI SPECIALI CR
                JE      EDFIL2
                CMP     AL,' '          ; SPAZIO
                JE      EDFIL3          ;   E
                CMP     AL,8            ; BACKSPACE
                JE      EDFIL4          ;CANCELLANO 1 CARATTERE
EDFILF1:        JMP     EDFILF
EDFIL2:         MOV     DS:NOMEFILE[SI],0
                JMP     EDFIL31
EDFIL3:         CALL    EDFILSUB
                JMP     EDFIL31
EDFIL4:         CMP     SI,0
                JE      EDFIL3
                DEC     SI
                CALL    EDFILSUB
                JMP     EDFIL32
EDFIL20:        MOV     AH,DS:NOMEFILE[SI]
                MOV     DS:NOMEFILE[SI],AL
                CMP     AH,0
                JNE     EDFIL30
                INC     SI
                MOV     DS:NOMEFILE[SI],0
EDFIL30:        CALL    DELCURS
                CALL    MOSTRAFILE
                MOV     LASTBOTTON,199
                CALL    SHOWCURS
                CALL    TASTODS
                JMP     EDFILF
EDFIL31:        CALL    DELCURS
                CALL    MOSTRAFILE
                MOV     LASTBOTTON,199
                CALL    SHOWCURS
                JMP     EDFILF
EDFIL32:        CALL    DELCURS
                CALL    MOSTRAFILE
                MOV     LASTBOTTON,199
                CALL    SHOWCURS
                CALL    TASTOSN
                JMP     EDFILF
EDFILF:         POP     SI
                POP     CX
                POP     BX
                POP     AX
                RET
EDITFILE        ENDP
 
;EDITOR SU NOME PATCH, UPPER, LOWER  AL CONTIENE IL CARATTERE
EDITNOMI        PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    SI
                XOR     BX,BX
                MOV     AH,CURSY
                CMP     AH,PATCHY
                JNE     EDNOM1
                MOV     BL,CURSX
                SUB     BL,PATCHX
                JL      EDNOM1
                CMP     BX,PATCHLEN
                JAE     EDNOM1          ;SIAMO IN ZONA PATCHNAME
                MOV     CX,64
                MOV     SI,0
EDNOML1:        CMP     AL,DS:ALFABETO[SI]
                JE      EDNOMT1
                INC     SI
                LOOP    EDNOML1
                JMP     EDNOMF1
EDNOMT1:        XCHG    BX,SI
                MOV     DS:PATCH[SI],BL
                CALL    DELCURS
                CALL    MOSTRAPATCH
                MOV     LASTBOTTON,213
                CALL    SHOWCURS
                CALL    TASTODS
EDNOMF1:        POP     SI
                POP     CX
                POP     BX
                POP     AX
                RET
EDNOM1:         CMP     AH,UPPERY
                JNE     EDNOM2
                MOV     BL,CURSX
                SUB     BL,UPPERX
                JL      EDNOM2
                CMP     BX,UPPERLEN
                JAE     EDNOM2          ;SIAMO IN ZONA UPPER
                MOV     CX,64
                MOV     SI,0
EDNOML2:        CMP     AL,DS:ALFABETO[SI]
                JE      EDNOMT2
                INC     SI
                LOOP    EDNOML2
                JMP     EDNOMF2
EDNOMT2:        XCHG    BX,SI
                MOV     DS:UCOMMON[SI],BL
                CALL    DELCURS
                CALL    MOSTRAUPPER
                MOV     LASTBOTTON,214
                CALL    SHOWCURS
                CALL    TASTODS
EDNOMF2:        POP     SI
                POP     CX
                POP     BX
                POP     AX
                RET
EDNOM2:         CMP     AH,LOWERY
                JNE     EDNOM3
                MOV     BL,CURSX
                SUB     BL,LOWERX
                JL      EDNOM3
                CMP     BX,LOWERLEN
                JAE     EDNOM3          ;SIAMO IN ZONA LOWER
                MOV     CX,64
                MOV     SI,0
EDNOML3:        CMP     AL,DS:ALFABETO[SI]
                JE      EDNOMT3
                INC     SI
                LOOP    EDNOML3
                JMP     EDNOM3
EDNOMT3:        XCHG    BX,SI
                MOV     DS:LCOMMON[SI],BL
                CALL    DELCURS
                CALL    MOSTRALOWER
                MOV     LASTBOTTON,215
                CALL    SHOWCURS
                CALL    TASTODS
EDNOM3:         POP     SI
                POP     CX
                POP     BX
                POP     AX
                RET
EDITNOMI        ENDP
 
;SCAMBIA I DUE BUFFER TONI2 E ADDUPARZ1 DI 560 BYTES CIASCUNO
;SCAMBIA I DUE NOMI FILE NOMEFILE2 E NOMEFILE
SCAMBIA         PROC    FAR
                PUSH    AX
                PUSH    SI
                PUSH    CX
                MOV     SI,0
                MOV     CX,560
SCAMBIA1:       MOV     AL,TONI2[SI]
                XCHG    AL,ADDUPARZ1[SI]
                MOV     TONI2[SI],AL
                INC     SI
                LOOP    SCAMBIA1
                MOV     SI,0
                MOV     CX,30
SCAMBIA2:       MOV     AL,NOMEFILE[SI]
                XCHG    AL,NOMEFILE2[SI]
                MOV     NOMEFILE[SI],AL
                INC     SI
                LOOP    SCAMBIA2
                POP     CX
                POP     SI
                POP     AX
                RET
SCAMBIA         ENDP
 
 
;
;ROUTINES NUMERATE
;
 
;PROCEDURA VUOTA                        N.0
NULL            PROC    FAR
                RET
NULL            ENDP
 
;PROCEDURA DI INIZIALIZZAZIONE DELL EDITORE     N.1
CONTROLLO1      PROC    FAR
;RESET SCHERMO
                MOV     AH,0            ;RESET DELLO SCHERMO
                MOV     AL,3            ;MODO TESTO
                INT     10H             ;80X25 COLOR ALPHA
                MOV     AL,3
                MOV     AH,10H
                MOV     BL,0            ;NIENTE BLINKING
                INT     10H
;SCHERMATA INIZIALE CON COLORE FONDO E SCRITTE
                PUSH    ES
                MOV     CX,ADDSCHERMO
                MOV     ES,CX
                MOV     CX,2000
C1LOOP1:        MOV     DI,CX
                MOV     AL,SCHERMATA[DI-1]
                MOV     AH,ATTFONDO+ATTSCRITTE
                SHL     DI,1
                MOV     ES:0[DI-2],AX
                LOOP    C1LOOP1
                POP     ES
                CALL    MOSTRAPATCH
                CALL    MOSTRAUPPER
                CALL    MOSTRALOWER
;COLORI E STATO BOTTONI
                XOR     CX,CX
                MOV     CL,NBOTTONI
                MOV     AX,0C1H        ;BOTTONE 1 STATOCURSORE
                MOV     DH,ATTBOTTNO+ATTNERO
C1LOOP2:        CALL    BOTTONESN
                CALL    BOTTONEST
                INC     AX
                LOOP    C1LOOP2
                MOV     BL,40           ;X
                MOV     BH,14           ;Y
                PUSH    AX
                PUSH    DX
                MOV     DH,ATTBOTTSI
                MOV     AL,212          ;ACCENDE AUTOFF
                CALL    BOTTONESN
                POP     DX
                POP     AX
                MOV     CURSX,BL
                MOV     CURSY,BH
                CALL    CURADDR
                MOV     CURADDRESS,AX
                CALL    SHOWCURS        ;CURSORE IN POSIZIONE INIZIALE
                MOV     DX,0509H        ;RIGA 8 COLONNA 10
                MOV     AH,2            ;SET CURSOR
                INT     10H             ;BIOS CALL
                CALL    OPZIONEUL       ;OPZIONE U+L ATTIVA
                MOV     ROUTINETA,30    ;ATTIVA MOVIMENTI CURSORE
                CALL    MOSTRAFILE      ;MOSTRA NOME FILE
                CALL    INITINT         ;INT 24  NUOVO
                MOV     ROUTINESP,25    ;INIZIALIZZA MIDI SU SP
                MOV     ROUTINECO,0     ;DISATTIVA CONTROLLO1
                MOV     DX,OFFSET MESSG1
                CALL    MESSAGGIO       ;MESSAGGIO DI BENVENUTO
                RET
CONTROLLO1      ENDP
 
;COMANDO SEMPLICE E ATTESA ACK
;STATI 0=DA INIZIARE  1=OUT COMANDO E ATTESA ACK  0FFH=FINITO OK
PUTCMD0         PROC    FAR                     ;N.8
                PUSH    AX
                PUSH    DX
                CMP     STATUSTR,00             ;PRIMA VOLTA
                JNE     PPFIN1                  ;STAI ATTENDENDO ACK
                MOV     STATUSTR,01H            ;OUT  COMANDO
                MOV     AL,COMBFR
                MOV     DX,COMPORT
                OUT     DX,AL
                JMP     PPFIN0
PPFIN1:         CMP     ACKNOWLEDGE,1           ;CONFERMA RICEZIONE?
                JNE     PPFIN0                  ;NO
                MOV     STATUSTR,0FFH   ;LAVORO FINITO
                MOV     ROUTINETR,0     ;    DISATTIVATI
PPFIN0:         POP     DX
                POP     AX
                RET
PUTCMD0         ENDP
 
;COMANDO CON TRASMISSIONE DATI DOPO ACK
PUTCMD1         PROC    FAR                     ;N.9
                PUSH    AX
                PUSH    CX
                PUSH    DI
                PUSH    DX
                CMP     STATUSTR,00H
                JE      PUT1PASSO1      ;INIZIO TRASMISSIONE
                CMP     STATUSTR,11H
                JE      PUT1PASSO2      ;SI ATTENDE ACK
                CMP     STATUSTR,12H
                JE      PUT1PASSO4      ;STA TRASMETTENDO I DATI
                POP     DX              ;STATUS 0FFH, LAVORO FINITO
                POP     DI
                POP     CX
                POP     AX
                RET
PUT1PASSO1:     MOV     STATUSTR,11H            ;TRASMESSO COMANDO
                MOV     AL,COMBFR               ; ORA ATTENDI
                MOV     DX,COMPORT              ;  ACK  PER TRASMETTERE
                OUT     DX,AL
                POP     DX
                POP     DI
                POP     CX
                POP     AX
                RET
PUT1PASSO2:     CMP     ACKNOWLEDGE,1           ;SE ARRIVATO ACK
                JE      PUT1PASSO3              ; INIZIA TRASMISSIONE
                POP     DX                      ;ALTRIMENTI ASPETTA
                POP     DI
                POP     CX
                POP     AX
                RET
PUT1PASSO3:     MOV     STATUSTR,12H            ;INIZIO TRASMISSIONE DATI
                XOR     CX,CX
                MOV     PTRDATICOM,CX
PUT1PASSO4:     MOV     DI,PTRDATICOM
                MOV     AL,BDATICOM[DI]
                MOV     DX,DATAPORT
                OUT     DX,AL
                INC     DI
                CMP     DI,NDATICOM
                JGE     PUT1PASSO5
                MOV     PTRDATICOM,DI
                POP     DX
                POP     DI
                POP     CX
                POP     AX
                RET
PUT1PASSO5:     MOV     STATUSTR,0FFH           ;DATI FINITI
                MOV     ROUTINETR,0             ;DISATTIVATI
                POP     DX
                POP     DI
                POP     CX
                POP     AX
                RET
PUTCMD1         ENDP
 
 
;COMANDO CON RICEZIONE 1 DATO DOPO ACK
                PUBLIC  PUTCMD2
PUTCMD2         PROC    FAR                     ;N.10
RICEZ1:         NOP                     ; DA FINIRE PER ORA NON SERVE
                RET
PUTCMD2         ENDP
 
;RICEVE DATO E LO ESAMINA
;RICONOSCE  ACK, SYSTEM MESSAGE, EXCLUSIVE INIZIO ,ROLAND, D50,EXCLUSIVE FINE
;RICEVE DATI IN UN BUFFER  BDATIIN, PUNTATORE PTRDATIIN
;STATI RICEZIONE:
;0=DA INIZIARE  10H=SYSTEM MESSAGE INIZIO 11H=EXCLU  MESSAGE INIZIO
;12=ROLAND 13=CANALE0 14=D50 15=DT1 16=DATI IN ARRIVO FFH=FINE DATI EXCLU
;SE ARRIVANO PORCHERIE SONO IGNORATE
;SE ARRIVA MESSAGGIO QUANDO STATUSRC/=0, E CIOE I DATI NON SONO STATI
;DIGERITI, VIENE IGNORATO
;MANCA CONTROLLO BUFFER OVERFLOW
GETDATA         PROC    FAR                     ;N.20
                PUSH    AX
                PUSH    DX
                PUSH    SI
                MOV     DX,DATAPORT
                IN      AL,DX                   ;DATO RICEVUTO IN AL
;MESSAGGIO MPU ?
                CMP     AL,ACK                  ;ACKNOWLEDGE
                JE      ACKCOM
                CMP     AL,SYSINI               ;SYSTEM MESSAGE
                JE      SYSMESSIN
                CMP     AL,ENDEXCLU
                JE      SYSMESSFIN              ;CHIUDE MESSAGGI MIDI
;ALLORA SI TRATTA DI UN DATO O DI UN MESSAGGIO CHE NON CI INTERESSA
                JMP     ALTROIN
ACKCOM:         MOV     ACKNOWLEDGE,1
                JMP     FINEGETDATA1
SYSMESSIN:      CMP     STATUSRC,0H
                JNE     FINEGETDATA1  ;NON ACCETTA MESSAGGIO NON RICHIESTO
                MOV     STATUSRC,10H
                JMP     FINEGETDATA1
SYSMESSFIN:     NOP  ;SE NON STAVA RICEVENDO EXCLU SEGNALARE ERRORE
                MOV     STATUSRC,0FFH
                MOV     AX,PTRDATIIN
                MOV     NDATIIN,AX      ;TOTALE DATI
FINEGETDATA1:   JMP     FINEGETDATA
ALTROIN:        CMP     STATUSRC,10H
                JE      PRIMODATO       ;INIZIO MESSAGGIO EXCLUSIVO MIDI
                CMP     STATUSRC,11H
                JE      SECONDODATO
                CMP     STATUSRC,12H
                JE      TERZODATO
                CMP     STATUSRC,13H
                JE      QUARTODATO
                CMP     STATUSRC,14H
                JE      QUINTODATO
                CMP     STATUSRC,15H
                JE      PIUDATIIN
                JMP     NONGETDATA     ;IGNORA DATO
 
PRIMODATO:      CMP     AL,EXCLUINI
                JNE     NONGETDATA     ;NON MESSAGGIO EXCLU
                MOV     STATUSRC,11H
                JMP     FINEGETDATA     ;MESS EXCLU INIZIATO
SECONDODATO:    CMP     AL,ROLAND
                JNE     NONGETDATA
                MOV     STATUSRC,12H
                JMP     FINEGETDATA     ;DA UN ROLAND
TERZODATO:      CMP     AL,00H
                JNE     NONGETDATA
                MOV     STATUSRC,13H
                JMP     FINEGETDATA     ;DA CANALE 0
QUARTODATO:     CMP     AL,D50
                JNE     NONGETDATA
                MOV     STATUSRC,14H
                JMP     FINEGETDATA     ;DA UN D50
QUINTODATO:     CMP     AL,DT1
                JNE     NONGETDATA
                MOV     STATUSRC,15H
                MOV     PTRDATIIN,0H
                JMP     FINEGETDATA     ;INIZIODATI
PIUDATIIN:      MOV     SI,PTRDATIIN
                MOV     BDATIIN[SI],AL
                INC     SI
                MOV     PTRDATIIN,SI
                JMP     FINEGETDATA
NONGETDATA:     MOV     STATUSRC,0      ;I DATI NON ERANO QUELLI ATTESI
FINEGETDATA:    POP     SI              ;NON SI DISATTIVA MAI DA SE
                POP     DX
                POP     AX
                RET
GETDATA         ENDP
 
;INIZIALIZZA MIDI                       N.25
;STATI  0=DA INIZIARE, 1=ATTESA FINE PRIMO 2= ATTESA FINE SECONDO
INITMIDI        PROC    FAR
                CMP     STATUSSP,0EEH   ;TIMEOUT
                JE      MPUTIMEOUT      ;LA MPU NON VA
                CMP     STATUSSP,2      ;ATTENDE FINE SECONDO COMANDO
                JE      INIMI2
                CMP     STATUSSP,1      ;ATTENDE FINE PRIMO COMANDO
                JE      INIMI1
;ALLORA DEVE ESSERE 0
                MOV     COMBFR,RESETTA  ;INIZIA QUI
                MOV     ROUTINERC,20    ;ROUTINE DI RICEZIONE INIZIA
                MOV     ROUTINETR,8     ;TRASMETTE COMANDO SEMPLICE
                MOV     STATUSSP,1
                RET
INIMI1:         CMP     STATUSTR,0FFH   ;FINITO?
                JE      INIMIPAS2
                RET
INIMIPAS2:      MOV     STATUSSP,2
                MOV     COMBFR,RICEVIEXCLU
                MOV     STATUSTR,0
                MOV     ROUTINETR,8     ;TRASMETTE COMANDO SEMPLICE
INIMI2:         CMP     STATUSTR,0FFH   ;FINITO?
                JE      INIMI3
                RET
MPUTIMEOUT:     MOV     DX,OFFSET MESSG26  ;MPU NON RISPONDE
                CALL    MESSAGGIO
                MOV     ERRORSP,1       ;PRENDI NOTA
 
INIMI3:         MOV     STATUSSP,0      ;DISATTIVATI
                MOV     ROUTINESP,0
                MOV     STATUSTR,0      ;DISATTIVA TRASMISSIONE
                MOV     ROUTINETR,0
                RET
INITMIDI        ENDP
 
;LEGGE TASTO E MUOVE CURSORE           N.30
MOVCURS         PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DX
                MOV     DL,0FFH         ;LEGGE TASTO
                MOV     AH,6
                INT     21H
                CMP     AL,0
                JNE     MCTASTO         ;TASTO NORMALE
                MOV     DL,0FFH         ;TASTO ESTESO
                MOV     AH,6            ;LEGGI UN ALTRO CARATTERE
                INT     21H             ;GESTIONE FRECCIE QUI
                CMP     AL,ARROWSU
                JE      MCTASTOSU
                CMP     AL,ARROWGIU
                JE      MCTASTOGIU
                CMP     AL,ARROWDS
                JE      MCTASTODS
                CMP     AL,ARROWSN
                JE      MCTASTOSN
                CMP     AL,ARROWPGAV
                JE      MCDECDATO
                CMP     AL,ARROWPGIND
                JE      MCINCDATO
                JMP     MCEND
MCDECDATO:      CALL    DECDATO
                JMP     MCEND
MCINCDATO:      CALL    INCDATO
                JMP     MCEND
MCTASTO:        CALL    SEBOTTONE       ; RETURN CHE ATTIVA BOTTONE ?
                CALL    EDITDATI        ; EDITOR SU CAMPO DATI
                CALL    EDITFILE
                CALL    EDITNOMI
                JMP     MCEND
MCTASTOSU:      CALL    TASTOSU
                JMP     MCEND
MCTASTOGIU:     CALL    TASTOGIU
                JMP     MCEND
MCTASTODS:      CALL    TASTODS
                JMP     MCEND
MCTASTOSN:      CALL    TASTOSN
MCEND:          POP     DX
                POP     CX
                POP     BX
                POP     AX
                RET
MOVCURS         ENDP
 
 
;USCITA DAL PROGRAMMA PRINCIPALE        N.193      BOTTONE1
ESCIMAIN        PROC    FAR
                MOV     AH,0            ;RESET DELLO SCHERMO
                MOV     AL,3            ;MODO TESTO
                INT     10H             ;80X25 COLOR ALPHA
                MOV     LASTBOTTON,193
                POP AX
                POP AX
                RET
ESCIMAIN        ENDP
 
;LEGGE I DATI DAL D50                   N.194      BOTTONE2
;QUALI DATI DIPENDE DA OPZIONEUPLO
;I BLOCCHI SPEDITI SONO DA 64 BYTES CIASCUNO
;OPZIONEUPLO=1 BLOCCHI 1 2 3 4 5 6 7
;OPZIONEUPL0=2 BLOCCHI 1 2 3
;OPZIONEUPL0=3 BLOCCHI 4 5 6
;STATUS 0=DA INIZIARE  1=CHIEDE BLOCCO1,SE SERVE 2=LEGGE BLOCCO1 SE
;RICHIESTO 3=CHIEDE BLOCCO2, SE SERVE 4=LEGGE BLOCCO2 ....
;80H=FAILURE
;NOTA: OPZIONEUPLO VIENE CONGELATA IN OPZIONEXX
READD50         PROC    FAR
                PUSH    AX
                PUSH    DX
                PUSH    CX
                MOV     AL,STATUSCO
                CMP     AL,0
                JE      LLINI
                CMP     AL,1
                JE      LLRQS1A
                CMP     AL,2
                JE      LLSND1A
                CMP     AL,3
                JE      LLRQS2A
                CMP     AL,4
                JE      LLSND2A
                CMP     AL,5
                JE      LLRQS3A
                CMP     AL,6
                JE      LLSND3A
                CMP     AL,7
                JE      LLRQS4A
                CMP     AL,8
                JE      LLSND4A
                CMP     AL,9
                JE      LLRQS5A
                CMP     AL,10
                JE      LLSND5A
                CMP     AL,11
                JE      LLRQS6A
                CMP     AL,12
                JE      LLSND6A
                CMP     AL,13
                JE      LLRQS7A
                CMP     AL,14
                JE      LLSND7A
                JMP     LLEND1
LLINI:          MOV     AL,OPZIONEUPLO
                MOV     OPZIONEXX,AL    ;CONGELATO OPZIONE
                CMP     STATUSTR,0      ;TRASMISSIONE IN CORSO ?
                JNE     LLABORT11       ;ALLORA NON POSSO TRASMETTERE
                CMP     OPZIONEXX,3
                JE      LLSNDLS1        ;PASSA SUBITO AL BLOCCO 4
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,1
                CALL    DRQST          ;PREPARA DATI RICHIESTA1
                MOV     STATUSCO,1
                JMP     LLEND1
LLRQS1A:        JMP     LLRQS1
LLSND1A:        JMP     LLSND1
LLRQS2A:        JMP     LLRQS2
LLSND2A:        JMP     LLSND2
LLRQS3A:        JMP     LLRQS3
LLSND3A:        JMP     LLSND3
LLRQS4A:        JMP     LLRQS4
LLSND4A:        JMP     LLSND4
LLRQS5A:        JMP     LLRQS5
LLSND5A:        JMP     LLSND5
LLRQS6A:        JMP     LLRQS6
LLSND6A:        JMP     LLSND6
LLRQS7A:        JMP     LLRQS7
LLSND7A:        JMP     LLSND7
LLABORT11:      JMP     LLABORT1
LLRQS1:         CMP     STATUSTR,0FFH
                JNE     LLEND1          ;ATTESA
                MOV     STATUSCO,2
LLSND1:         CMP     STATUSRC,0FFH   ;FINE ARRIVO DATI
                JNE     LLEND1          ;SE NO ATTESA
                CALL    LLIBB1          ;LIBERA BUFFER  E VARIE RICEZIONE
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,2
                CALL    DRQST          ;PREPARA DATI RICHIESTA2 E STATOTR
                MOV     STATUSCO,3
LLEND1:         JMP     LLEND2
LLSNDLS1:       JMP     LLSNDLS
LLRQS2:         CMP     STATUSTR,0FFH
                JNE     LLEND2          ;ATTESA
                MOV     STATUSCO,4
LLSND2:         CMP     STATUSRC,0FFH   ;FINE ARRIVO DATI
                JNE     LLEND2          ;SE NO ATTESA
                CALL    LLIBB2          ;LIBERA BUFFER  E VARIE RICEZIONE
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,3
                CALL    DRQST          ;PREPARA DATI RICHIESTA3
                MOV     STATUSCO,5
                JMP     LLEND2
LLABORT1:       JMP     LLABORT2
LLRQS3:         CMP     STATUSTR,0FFH
                JNE     LLEND2          ;ATTESA
                MOV     STATUSCO,6
LLSND3:         CMP     STATUSRC,0FFH   ;FINE ARRIVO DATI
                JNE     LLEND2          ;SE NO ATTESA
                CALL    LLIBB3          ;LIBERA BUFFER  E VARIE RICEZIONE
                CMP     OPZIONEXX,2     ;
                JE      LLFIN1          ;SE SOLO UPPER HA FINITO
LLSNDLS:        MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,4
                CALL    DRQST          ;PREPARA DATI RICHIESTA4
                MOV     STATUSCO,7
LLEND2:         JMP     LLEND3
LLRQS4:         CMP     STATUSTR,0FFH
                JNE     LLEND3          ;ATTESA
                MOV     STATUSCO,8
LLSND4:         CMP     STATUSRC,0FFH   ;FINE ARRIVO DATI
                JNE     LLEND3          ;SE NO ATTESA
                CALL    LLIBB4          ;LIBERA BUFFER  E VARIE RICEZIONE
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,5
                CALL    DRQST          ;PREPARA DATI RICHIESTA5
                MOV     STATUSCO,9
                JMP     LLEND3
LLRQS5:         CMP     STATUSTR,0FFH
                JNE     LLEND3          ;ATTESA
                MOV     STATUSCO,10
LLSND5:         CMP     STATUSRC,0FFH   ;FINE ARRIVO DATI
                JNE     LLEND3          ;SE NO ATTESA
                CALL    LLIBB5          ;LIBERA BUFFER  E VARIE RICEZIONE
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,6
                CALL    DRQST          ;PREPARA DATI RICHIESTA6
                MOV     STATUSCO,11
LLEND3:         JMP     LLEND4
LLFIN1:         JMP     LLFIN
LLABORT2:       JMP     LLABORT
LLRQS6:         CMP     STATUSTR,0FFH
                JNE     LLEND4          ;ATTESA
                MOV     STATUSCO,12
LLSND6:         CMP     STATUSRC,0FFH   ;FINE ARRIVO DATI
                JNE     LLEND4          ;SE NO ATTESA
                CALL    LLIBB6          ;LIBERA BUFFER  E VARIE RICEZIONE
                CMP     OPZIONEXX,1
                JNE     LLFIN           ;SOLO U+L LEGGE PATCH
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,7
                CALL    DRQST          ;PREPARA DATI RICHIESTA7
                MOV     STATUSCO,13
                JMP     LLEND4
LLRQS7:         CMP     STATUSTR,0FFH
                JNE     LLEND4          ;ATTESA
                MOV     STATUSCO,14
LLSND7:         CMP     STATUSRC,0FFH   ;FINE ARRIVO DATI
                JNE     LLEND4          ;SE NO ATTESA
                CALL    LLIBB7          ;LIBERA BUFFER  E VARIE RICEZIONE
                JMP     LLFIN
LLABORT:        MOV    DX,OFFSET MESSG8
                CALL   MESSAGGIO        ;NON RIESCO A TRASMETTERE
                MOV    STATUSCO,80H     ;FAILURE
LLEND4:         JMP    LLEND
LLFIN:          CALL    DELCURS         ;SPEGNE BOTTONE
                MOV     DH,ATTBOTTNO
                MOV     AL,194          ;NUMERO BOTTONE
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     STATUSTR,0      ;
                MOV     STATUSCO,0
                MOV     ROUTINECO,0     ;DISATTIVA ROUTINE
                MOV     LASTBOTTON,194
                CMP     OPZIONEXX,1
                JE      LLUPIULMESS
                CMP     OPZIONEXX,2
                JE      LLSOLOUMESS
                CMP     OPZIONEXX,3
                JE      LLSOLOLMESS
LLUPIULMESS:    MOV     DX,OFFSET MESSG5
                CALL    MESSAGGIO
                CALL    MOSTRAPATCH
                CALL    MOSTRALOWER
                CALL    MOSTRAUPPER
                CALL    AGGDATI
                JMP     LLEND
LLSOLOUMESS:    MOV     DX,OFFSET MESSG6
                CALL    MESSAGGIO
                CALL    MOSTRAUPPER
                CALL    AGGDATI
                JMP     LLEND
LLSOLOLMESS:    MOV     DX,OFFSET MESSG7
                CALL    MESSAGGIO
                CALL    MOSTRALOWER
                CALL    AGGDATI
LLEND:          POP     CX
                POP     DX
                POP     AX
                RET
READD50         ENDP
 
;LEGGE IL PATCH DA FILE DI NOME IN FILENAME  N.195  BOTTONE3
;CODICE CARICATO COME ROUTINEFI
READFILE        PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    DX
                PUSH    CX
                CMP     NOMEFILE,0
                JE      READFVUOTO             ;NOMEFILE VUOTO!
                MOV     DX,OFFSET NOMEFILE
                MOV     AX,3D00H
                INT     21H
                JNC     RFOPENOK               ;SE IL FILE  ESISTE
                CMP     STATUSFI,0EEH
                JE      REDIERR
READFVUOTO:     MOV     DX,OFFSET MESSG17      ;FILE NON TROVATO
                CALL    MESSAGGIO
                JMP     RFEND
RFOPENOK:       MOV     FHANDLE,AX
                MOV     BX,FHANDLE
                CMP     STATUSFI,0EEH
                JE      REDIERR
                MOV     CX,560
                MOV     DX,OFFSET ADDUPARZ1
                MOV     AH,3FH
                INT     21H
                CMP     STATUSFI,0EEH
                JE      REDIERR
                CMP     AX,560
                JNE     RFNONLETTO
                XOR     AX,AX
                MOV     AH,3EH
                MOV     BX,FHANDLE
                INT     21H                     ;CLOSE FILE
                CMP     STATUSFI,0EEH
                JE      REDIERR
                MOV     DX, OFFSET MESSG18
                CALL    MESSAGGIO
                JMP     RFEND
REDIERR:        MOV     DX, OFFSET MESSG24
                CALL    MESSAGGIO
                JMP     RFEND
RFNONLETTO:     MOV     DX, OFFSET MESSG15
                CALL    MESSAGGIO
RFEND:          CALL    DELCURS
                CALL    MOSTRAPATCH
                CALL    MOSTRALOWER
                CALL    MOSTRAUPPER
                CALL    AGGDATI
                MOV     DH,ATTBOTTNO
                MOV     AL,195
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     ROUTINEFI,0     ;DISATTIVA ROUTINE
                MOV     STATUSFI,0
                MOV     LASTBOTTON,195
                POP     CX
                POP     DX
                POP     BX
                POP     AX
                RET
READFILE        ENDP
 
;SCRIVEI DATI SUL D50                   N.196      BOTTONE4
;QUALI DATI DIPENDE DA OPZIONEUPLO
;I BLOCCHI SPEDITI SONO DA 64 BYTES CIASCUNO
;OPZIONEUPLO=1 BLOCCHI 1 2 3 4 5 6 7
;OPZIONEUPL0=2 BLOCCHI 1 2 3
;OPZIONEUPL0=3 BLOCCHI 4 5 6
;STATUS 0=DA INIZIARE  1=SCRIVE BLOCCO1,SE SERVE  2=SCRIVE BLOCCO2 ...
;80H=FAILURE
;NOTA: OPZIONEUPLO VIENE CONGELATA IN OPZIONEXX
WRITED50        PROC    FAR
                PUSH    AX
                PUSH    DX
                PUSH    CX
                MOV     AL,STATUSCO
                CMP     AL,0
                JE      WWINI
                CMP     AL,1
                JE      WWSND1
                CMP     AL,2
                JE      WWSND2A
                CMP     AL,3
                JE      WWSND3A
                CMP     AL,4
                JE      WWSND4A
                CMP     AL,5
                JE      WWSND5A
                CMP     AL,6
                JE      WWSND6A
                CMP     AL,7
                JE      WWSND7A
                JMP     WWEND1
WWINI:          MOV     AL,OPZIONEUPLO
                MOV     OPZIONEXX,AL    ;CONGELATO OPZIONE
                CMP     STATUSTR,0      ;TRASMISSIONE IN CORSO ?
                JNE     WWABORT11       ;ALLORA NON POSSO TRASMETTERE
                CMP     OPZIONEXX,3
                JE      WWSL1           ;LOWER NON FA 1 2 3
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,1
                CALL    WWSEND         ;PREPARA DATI BLOCCO1
                MOV     STATUSCO,1
                JMP     WWEND1
WWSND2A:        JMP     WWSND2
WWSND3A:        JMP     WWSND3
WWSND4A:        JMP     WWSND4
WWSND5A:        JMP     WWSND5
WWSND6A:        JMP     WWSND6
WWSND7A:        JMP     WWSND7
WWABORT11:      JMP     WWABORT1
WWSL1:          JMP     WWSL
WWSND1:         CMP     STATUSTR,0FFH
                JNE     WWEND1          ;ATTESA
                MOV     STATUSCO,2
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,2
                CALL    WWSEND         ;PREPARA DATI BLOCCO2
WWEND1:         JMP     WWEND2
WWSND2:         CMP     STATUSTR,0FFH
                JNE     WWEND2          ;ATTESA
                MOV     STATUSCO,3
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,3
                CALL    WWSEND         ;PREPARA DATI BLOCCO3
                JMP     WWEND2
WWABORT1:       JMP     WWABORT2
WWSND3:         CMP     STATUSTR,0FFH
                JNE     WWEND2          ;ATTESA
                CMP     OPZIONEXX,2
                JE      WWFIN1          ;U HA FINITO
WWSL:           MOV     STATUSCO,4
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,4
                CALL    WWSEND         ;PREPARA DATI BLOCCO4
WWEND2:         JMP     WWEND3
WWSND4:         CMP     STATUSTR,0FFH
                JNE     WWEND3          ;ATTESA
                MOV     STATUSCO,5
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,5
                CALL    WWSEND         ;PREPARA DATI BLOCCO5
                JMP     WWEND3
WWSND5:         CMP     STATUSTR,0FFH
                JNE     WWEND3          ;ATTESA
                MOV     STATUSCO,6
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,6
                CALL    WWSEND         ;PREPARA DATI BLOCCO6
WWEND3:         JMP     WWEND4
WWABORT2:       JMP     WWABORT
WWFIN1:         JMP     WWFIN
WWSND6:         CMP     STATUSTR,0FFH
                JNE     WWEND4          ;ATTESA
                CMP     OPZIONEXX,1
                JNE     WWFIN           ;SOLO U+L TRASMETTE PATCH
                MOV     STATUSCO,7
                MOV     COMBFR,WANTSEND
                MOV     ROUTINETR,9     ;TRASMETTI COMANDO E DATI
                MOV     AL,7
                CALL    WWSEND        ;PREPARA DATI RICHIESTA7
                JMP     WWEND4
WWSND7:         CMP     STATUSTR,0FFH
                JNE     WWEND4          ;ATTESA
                JMP     WWFIN
WWABORT:        MOV     DX,OFFSET MESSG6
                CALL    MESSAGGIO        ;NON RIESCO A TRASMETTERE
                MOV     STATUSCO,80H     ;FAILURE
WWEND4:         JMP     WWEND
WWFIN:          CALL    DELCURS         ;SPEGNE BOTTONE
                MOV     DH,ATTBOTTNO
                MOV     AL,196
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     STATUSTR,0      ;
                MOV     STATUSCO,0
                MOV     ROUTINECO,0     ;DISATTIVA ROUTINE
                MOV     LASTBOTTON,196
                CMP     OPZIONEXX,1
                JE      WWUPIULMESS
                CMP     OPZIONEXX,2
                JE      WWSOLOUMESS
                CMP     OPZIONEXX,3
                JE      WWSOLOLMESS
WWUPIULMESS:    MOV     DX,OFFSET MESSG9
                CALL    MESSAGGIO
                JMP     WWEND
WWSOLOUMESS:    MOV     DX,OFFSET MESSG10
                CALL    MESSAGGIO
                JMP     WWEND
WWSOLOLMESS:    MOV     DX,OFFSET MESSG11
                CALL    MESSAGGIO
WWEND:          POP     CX
                POP     DX
                POP     AX
                RET
WRITED50        ENDP
 
;SCRIVE IL PATCH SUL FILE DI NOME IN FILENAME  N.197  BOTTONE5
;CODICE CARICATO COME ROUTINEFI
WRITEFILE       PROC    FAR
                PUSH    AX
                PUSH    DX
                PUSH    CX
                CMP     NOMEFILE,0
                JE      WRDIFFVAR               ;NOMEFILE VUOTO !
                MOV     AL,01H                  ;SCRITTURA
                MOV     AH,3DH                  ;APRI FILE
                MOV     DX,OFFSET NOMEFILE
                INT     21H                     ;OPEN FILE
                JNC     ESISTE                  ;SE ESISTE GIA
                CMP     STATUSFI,0EEH
                JE      WRDIERR1
                CMP     AX,02H                  ;FILE NOT FOUND
                JZ      CREA                    ;ALLORA CREALO
WRDIFFVAR:      MOV     DX,OFFSET MESSG21       ;DIFFICOLOTA VARIE
                CALL    MESSAGGIO
                JMP     WRFILEEND
CREA:           MOV     CX,20H                  ;ATTRIBUTE BIT
                MOV     AH,3CH
                MOV     DX,OFFSET NOMEFILE
                INT     21H                     ;CREATO FILE
                JZ      BENE
                CMP     STATUSFI,0EEH
                JE      WRDIERR1
                MOV     DX,OFFSET MESSG20       ;CREAZIONE FALLITA
                CALL    MESSAGGIO
                JMP     WRFILEEND
BENE:           MOV     FHANDLE,AX
                CMP     STATUSFI,0EEH
                JE      WRDIERR
                MOV     CX,560
                MOV     BX,FHANDLE
                MOV     DX,OFFSET ADDUPARZ1
                MOV     AH,40H
                INT     21H
                CMP     STATUSFI,0EEH
                JE      WRDIERR
                CMP     AX,560
                JE      SCRITTO
                MOV     DX,OFFSET MESSG21       ;SCRITTURA FALLITA
                CALL    MESSAGGIO
                JMP     WRFILEEND
WRDIERR1:       JMP     WRDIERR
SCRITTO:        MOV     DX,OFFSET MESSG22       ;SCRITTURA OK
                CALL    MESSAGGIO
                JMP     WRFILECL
ESISTE:         CMP     LASTBOTTON,197
                JE      BENE                    ;QUESTA E' LA CONFERMA
                MOV     FHANDLE,AX
                MOV     DX,OFFSET MESSG19       ;ESISTE FILE
                CALL    MESSAGGIO
WRFILECL:       XOR     AX,AX
                MOV     AH,3EH
                MOV     BX,FHANDLE
                INT     21H                     ;CLOSE FILE
                CMP     STATUSFI,0EEH
                JE      WRDIERR
WRFILEEND:      MOV     LASTBOTTON,197
                CALL    DELCURS
                MOV     DH,ATTBOTTNO
                MOV     AL,197
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     STATUSFI,0
                MOV     ROUTINEFI,0     ;DISATTIVA ROUTINE
                POP     CX
                POP     DX
                POP     AX
                RET
WRDIERR:        MOV    DX,OFFSET MESSG25
                CALL   MESSAGGIO
                JMP    WRFILEEND
WRITEFILE       ENDP
 
;SCAMBIA I DUE FILES            BOTTONE 7   N.199
BOTTFILE        PROC    FAR
                PUSH    AX
                PUSH    DX
                PUSH    CX
                PUSH    BX
                MOV     CX,2000H       ;PAUSA PER FAR VEDERE IL COLORE
BBBB1:          MUL     BL
                LOOP    BBBB1
                CALL    SCAMBIA
                CALL    MOSTRAPATCH
                CALL    MOSTRAUPPER
                CALL    MOSTRALOWER
                CALL    MOSTRAFILE
                CALL    AGGDATI
                CALL    DELCURS
                MOV     DH,ATTBOTTNO
                MOV     AL,STATOCURSORE
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     ROUTINECO,0     ;DISATTIVA ROUTINE
                MOV     LASTBOTTON,199
                POP     BX
                POP     CX
                POP     DX
                POP     AX
                RET
BOTTFILE        ENDP
 
;EDITA PATCH            BOTTONE 8      N.200
BOTTPATCH       PROC    FAR
                CALL    BOTTEDITSHOW ;DISATTIVA GLI ALTRI BOTTONI EDIT
                                     ;E MOSTRA BOTTONE E CURSORE
                MOV     OFFVAR, OFFSET PATCH
                CMP     OFFETICH,OFFSET ETICHPATCH
                JE      BTPATCH      ;NON OCCORRE RIDISEGNARE ETICHETTE
                MOV     OFFETICH,OFFSET ETICHPATCH
                MOV     OFFTIPOVAR,OFFSET TIPOVARPATCH
                MOV     OFFMAXVAL,OFFSET MAXVALPATCH
                CALL    SHOWETICHALL
BTPATCH:        CALL    SHOWVARALL
                MOV     LASTBOTTON,200
                MOV     ROUTINECO,0   ;DISATTIVA ROUTINE
                RET
BOTTPATCH       ENDP
 
;EDITA UCOMMON          BOTTONE 9      N.201
;CARICATO COME CODSP
BOTTUCOMM       PROC    FAR
                CALL    BOTTEDITSHOW ;DISATTIVA GLI ALTRI BOTTONI EDIT
                                     ;E MOSTRA BOTTONE E CURSORE
                MOV     OFFVAR, OFFSET UCOMMON
                CMP     OFFETICH,OFFSET ETICHCOMM
                JE      BTUC1        ;NON OCCORRE RIDISEGNARE ETICHETTE
                MOV     OFFETICH,OFFSET ETICHCOMM
                MOV     OFFTIPOVAR,OFFSET TIPOVARCOMM
                MOV     OFFMAXVAL,OFFSET MAXVALCOMM
                CALL    SHOWETICHALL
BTUC1:          CALL    SHOWVARALL
                MOV     LASTBOTTON,201
                MOV     ROUTINECO,0   ;DISATTIVA ROUTINE
                RET
BOTTUCOMM       ENDP
 
;EDITA UPARZ1            BOTTONE 10    N.202
;CARICATO COME CODSP
BOTTUPARZ1      PROC    FAR
                CALL    BOTTEDITSHOW ;DISATTIVA GLI ALTRI BOTTONI EDIT
                                     ;E MOSTRA BOTTONE E CURSORE
                MOV     OFFVAR, OFFSET UPARZ1
                CMP     OFFETICH,OFFSET ETICHPARZ
                JE      BTUPARZ1    ;NON OCCORRE RIDISEGNARE ETICHETTE
                MOV     OFFETICH,OFFSET ETICHPARZ
                MOV     OFFTIPOVAR,OFFSET TIPOVARPARZ
                MOV     OFFMAXVAL,OFFSET MAXVALPARZ
                CALL    SHOWETICHALL
BTUPARZ1:       CALL    SHOWVARALL
                MOV     LASTBOTTON,202
                MOV     ROUTINECO,0   ;DISATTIVA ROUTINE
                RET
BOTTUPARZ1      ENDP
 
;EDITA UPARZ2         BOTTONE  11      N.203
;CARICATO COME CODSP
BOTTUPARZ2      PROC    FAR
                CALL    BOTTEDITSHOW ;DISATTIVA GLI ALTRI BOTTONI EDIT
                                     ;E MOSTRA BOTTONE E CURSORE
                MOV     OFFVAR, OFFSET UPARZ2
                CMP     OFFETICH,OFFSET ETICHPARZ
                JE      BTUPARZ2    ;NON OCCORRE RIDISEGNARE ETICHETTE
                MOV     OFFETICH,OFFSET ETICHPARZ
                MOV     OFFTIPOVAR,OFFSET TIPOVARPARZ
                MOV     OFFMAXVAL,OFFSET MAXVALPARZ
                CALL    SHOWETICHALL
BTUPARZ2:       CALL    SHOWVARALL
                MOV     LASTBOTTON,203
                MOV     ROUTINECO,0   ;DISATTIVA ROUTINE
                RET
BOTTUPARZ2      ENDP
 
;EDITA LCOMMON        BOTTONE  12      N.204
;CARICATO COME CODSP
BOTTLCOMM       PROC    FAR
                CALL    BOTTEDITSHOW ;DISATTIVA GLI ALTRI BOTTONI EDIT
                                     ;E MOSTRA BOTTONE E CURSORE
                MOV     OFFVAR, OFFSET LCOMMON
                CMP     OFFETICH,OFFSET ETICHCOMM
                JE      BTLCOMM1     ;NON OCCORRE RIDISEGNARE ETICHETTE
                MOV     OFFETICH,OFFSET ETICHCOMM
                MOV     OFFTIPOVAR,OFFSET TIPOVARCOMM
                MOV     OFFMAXVAL,OFFSET MAXVALCOMM
                CALL    SHOWETICHALL
BTLCOMM1:       CALL    SHOWVARALL
                MOV     LASTBOTTON,204
                MOV     ROUTINECO,0   ;DISATTIVA ROUTINE
                RET
BOTTLCOMM       ENDP
 
;EDITA LPARZ1        BOTTONE   13      N.205
;CARICATO COME CODSP
BOTTLPARZ1      PROC    FAR
                CALL    BOTTEDITSHOW ;DISATTIVA GLI ALTRI BOTTONI EDIT
                                     ;E MOSTRA BOTTONE E CURSORE
                MOV     OFFVAR, OFFSET LPARZ1
                CMP     OFFETICH,OFFSET ETICHPARZ
                JE      BTLPARZ1     ;NON OCCORRE RIDISEGNARE ETICHETTE
                MOV     OFFETICH,OFFSET ETICHPARZ
                MOV     OFFTIPOVAR,OFFSET TIPOVARPARZ
                MOV     OFFMAXVAL,OFFSET MAXVALPARZ
                CALL    SHOWETICHALL
BTLPARZ1:       CALL    SHOWVARALL
                MOV     LASTBOTTON,205
                MOV     ROUTINECO,0   ;DISATTIVA ROUTINE
                RET
BOTTLPARZ1      ENDP
 
;EDITA LPARZ2           BOTTONE  14    N.206
;CARICATO COME CODSP
BOTTLPARZ2      PROC    FAR
                CALL    BOTTEDITSHOW ;DISATTIVA GLI ALTRI BOTTONI EDIT
                                     ;E MOSTRA BOTTONE E CURSORE
                MOV     OFFVAR, OFFSET LPARZ2
                CMP     OFFETICH,OFFSET ETICHPARZ
                JE      BTLPARZ2     ;NON OCCORRE RIDISEGNARE ETICHETTE
                MOV     OFFETICH,OFFSET ETICHPARZ
                MOV     OFFTIPOVAR,OFFSET TIPOVARPARZ
                MOV     OFFMAXVAL,OFFSET MAXVALPARZ
                CALL    SHOWETICHALL
BTLPARZ2:       CALL    SHOWVARALL
                MOV     LASTBOTTON,206
                MOV     ROUTINECO,0   ;DISATTIVA ROUTINE
                RET
BOTTLPARZ2      ENDP
 
;OPZIONE UPPER+LOWER                    N.207
BOTTUL          PROC    FAR
                MOV     OPZIONEUPLO,1
                CALL    OPZIONEUL
                MOV     ROUTINECO,0     ;DISATTIVA ROUTINE
                MOV     LASTBOTTON,207
                PUSH    DX
                MOV     DX,OFFSET MESSG12
                CALL    MESSAGGIO
                POP     DX
                RET
BOTTUL          ENDP
 
;OPZIONE UPPER                          N.208
BOTTU           PROC    FAR
                MOV     OPZIONEUPLO,2
                CALL    OPZIONEUL
                MOV     ROUTINECO,0     ;DISATTIVA ROUTINE
                MOV     LASTBOTTON,208
                PUSH    DX
                MOV     DX,OFFSET MESSG13
                CALL    MESSAGGIO
                POP     DX
                RET
BOTTU           ENDP
 
;OPZIONE LOWER                          N.209
BOTTL           PROC    FAR
                MOV     OPZIONEUPLO,3
                CALL    OPZIONEUL
                MOV     ROUTINECO,0     ;DISATTIVA ROUTINE
                MOV     LASTBOTTON,209
                PUSH    DX
                MOV     DX,OFFSET MESSG14
                CALL    MESSAGGIO
                POP     DX
                RET
BOTTL           ENDP
 
;OPZIONE AUTOWRITE ON    BOTT 19        N.211
AUTOON          PROC    FAR
                PUSH    DX
                CALL    DELCURS
                MOV     DH,ATTBOTTNO
                MOV     AL,212          ;SPEGNE AUTOOFF
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     AUTO,1
                MOV     DX,OFFSET MESSG28
                CALL    MESSAGGIO
                CALL    DELCURS
                MOV     DH,ATTBOTTSI
                MOV     AL,211          ;ACCENDE AUTOON
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     ROUTINECO,0     ;DISATTIVA ROUTINE
                MOV     LASTBOTTON,211
                POP     DX
                RET
AUTOON          ENDP
 
 
;OPZIONE AUTOWRITE OFF   BOTT 20        N.212
AUTOOFF         PROC    FAR
                PUSH    DX
                CALL    DELCURS
                MOV     DH,ATTBOTTNO
                MOV     AL,211          ;SPEGNE AUTOON
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     AUTO,0
                MOV     DX,OFFSET MESSG29
                CALL    MESSAGGIO
                CALL    DELCURS
                MOV     DH,ATTBOTTSI
                MOV     AL,212          ;ACCENDE AUTOON
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     ROUTINECO,0     ;DISATTIVA ROUTINE
                MOV     LASTBOTTON,212
                POP     DX
                RET
AUTOOFF         ENDP
 
;BOTTONE INATTIVO               VARI NUMERI,PROVVISORIAMENTE
BOTTINATT       PROC    FAR
                PUSH    AX
                PUSH    DX
                PUSH    CX
                MOV     CX,4000H       ;PAUSA PER FAR VEDERE IL COLORE
BBBB:           MUL     BL
                LOOP    BBBB
                CALL    DELCURS
                MOV     DH,ATTBOTTNO
                MOV     AL,STATOCURSORE
                CALL    BOTTONESN
                CALL    SHOWCURS
                MOV     ROUTINECO,0     ;DISATTIVA ROUTINE
                MOV     LASTBOTTON,240
                POP     CX
                POP     DX
                POP     AX
                RET
BOTTINATT       ENDP
 
 
;
;PROGRAMMA PRINCIPALE CON POLLING CONTINUO TASTIERA,MPUTRASMIT,MPURECEIVE
;    PROGRAMMI IN ATTESA DI ESECUZIONE, OPERAZIONI SU FILE, E CONTROLLO.
 
MAIN            PROC    FAR                     ;ENTRY POINT FROM DOS
                PUSH    DS                      ;SET UP THE STACK TO HAVE
                XOR     AX,AX                   ; THE DOUBLE WORD VECTOR SO THE
                PUSH    AX                      ;  RETURN WILL GO BACK TO DOS
                MOV     AX,DSEG                 ;SET UP ADDRESSABILITY TO
                MOV     DS,AX                   ; THE DATA SEGMENT
                MOV     ES,AX                   ; AND EXTRA SEGMENT
;INIZIALIZZAZIONE
                ;TUTTI GLI STATUS SONO GIA 0H
                ;LE ROUTINETA,ROUTINERC,ROUTINETR,ROUTINESP,ROUTINEFI
                ;SON 0, CORRISPONDENTI A CHIAMARE NULL
                ;LA ROUTINECO = 1 CORRISPONDENTE A CONTROLLO1
 
;CARICA IN MEMORIA GLI INDIRIZZI DELLE ROUTINES
                MOV     WORD PTR ROUTINE[0],OFFSET NULL        ;0
                MOV     WORD PTR ROUTINE[2],SEG    NULL
                MOV     WORD PTR ROUTINE[4],OFFSET CONTROLLO1  ;1
                MOV     WORD PTR ROUTINE[6],SEG    CONTROLLO1
;               MOV     WORD PTR ROUTINE[8],OFFSET  LEGGINOMEF ;2
;               MOV     WORD PTR ROUTINE[10],SEG    LEGGINOMEF
;               MOV     WORD PTR ROUTINE[12],OFFSET NULL       ;3
;               MOV     WORD PTR ROUTINE[14],SEG    NULL
;
                MOV     WORD PTR ROUTINE[32],OFFSET PUTCMD0    ;8
                MOV     WORD PTR ROUTINE[34],SEG    PUTCMD0
                MOV     WORD PTR ROUTINE[36],OFFSET PUTCMD1    ;9
                MOV     WORD PTR ROUTINE[38],SEG    PUTCMD2
                MOV     WORD PTR ROUTINE[40],OFFSET PUTCMD2    ;10
                MOV     WORD PTR ROUTINE[42],SEG    PUTCMD2
 
                MOV     WORD PTR ROUTINE[80],OFFSET GETDATA    ;20
                MOV     WORD PTR ROUTINE[82],SEG    GETDATA
 
                MOV     WORD PTR ROUTINE[100],OFFSET INITMIDI   ;25
                MOV     WORD PTR ROUTINE[102],SEG    INITMIDI
;
                MOV     WORD PTR ROUTINE[120],OFFSET MOVCURS    ;30
                MOV     WORD PTR ROUTINE[122],SEG    MOVCURS
;               MOV     WORD PTR ROUTINE[124],OFFSET THRU       ;31
;               MOV     WORD PTR ROUTINE[126],SEG    THRU
;               MOV     WORD PTR ROUTINE[128],OFFSET QUITTA     ;32
;               MOV     WORD PTR ROUTINE[130],SEG    QUITTA
;               MOV     WORD PTR ROUTINE[132],OFFSET STARTER    ;33
;               MOV     WORD PTR ROUTINE[134],SEG    STARTER
;INSERIRNE ALTRI SECONDO NECESSITA
;               MOV     WORD PTR ROUTINE[128],OFFSET QUITTA     ;
;               MOV     WORD PTR ROUTINE[130],SEG    QUITTA
                MOV     WORD PTR ROUTINE[772],OFFSET ESCIMAIN   ;BOTT 1
                MOV     WORD PTR ROUTINE[774],SEG    ESCIMAIN   ;193
                MOV     WORD PTR ROUTINE[776],OFFSET READD50    ;BOTT 2
                MOV     WORD PTR ROUTINE[778],SEG    READD50    ;194
                MOV     WORD PTR ROUTINE[780],OFFSET READFILE   ;BOTT 3
                MOV     WORD PTR ROUTINE[782],SEG    READFILE   ;195
                MOV     WORD PTR ROUTINE[784],OFFSET WRITED50   ;BOTT 4
                MOV     WORD PTR ROUTINE[786],SEG    WRITED50   ;196
                MOV     WORD PTR ROUTINE[788],OFFSET WRITEFILE  ;BOTT 5
                MOV     WORD PTR ROUTINE[790],SEG    WRITEFILE  ;197
                MOV     WORD PTR ROUTINE[792],OFFSET BOTTINATT  ;BOTT 6
                MOV     WORD PTR ROUTINE[794],SEG    BOTTINATT  ;198
                MOV     WORD PTR ROUTINE[796],OFFSET BOTTFILE   ;BOTT 7
                MOV     WORD PTR ROUTINE[798],SEG    BOTTFILE   ;199
                MOV     WORD PTR ROUTINE[800],OFFSET BOTTPATCH  ;BOTT 8
                MOV     WORD PTR ROUTINE[802],SEG    BOTTPATCH  ;200
                MOV     WORD PTR ROUTINE[804],OFFSET BOTTUCOMM  ;BOTT 9
                MOV     WORD PTR ROUTINE[806],SEG    BOTTUCOMM  ;201
                MOV     WORD PTR ROUTINE[808],OFFSET BOTTUPARZ1 ;BOTT 10
                MOV     WORD PTR ROUTINE[810],SEG    BOTTUPARZ1 ;202
                MOV     WORD PTR ROUTINE[812],OFFSET BOTTUPARZ2 ;BOTT 11
                MOV     WORD PTR ROUTINE[814],SEG    BOTTUPARZ2 ;203
                MOV     WORD PTR ROUTINE[816],OFFSET BOTTLCOMM  ;BOTT 12
                MOV     WORD PTR ROUTINE[818],SEG    BOTTLCOMM  ;204
                MOV     WORD PTR ROUTINE[820],OFFSET BOTTLPARZ1 ;BOTT 13
                MOV     WORD PTR ROUTINE[822],SEG    BOTTLPARZ1 ;205
                MOV     WORD PTR ROUTINE[824],OFFSET BOTTLPARZ2 ;BOTT 14
                MOV     WORD PTR ROUTINE[826],SEG    BOTTLPARZ2 ;206
                MOV     WORD PTR ROUTINE[828],OFFSET BOTTUL     ;BOTT 15
                MOV     WORD PTR ROUTINE[830],SEG    BOTTUL     ;207
                MOV     WORD PTR ROUTINE[832],OFFSET BOTTU      ;BOTT 16
                MOV     WORD PTR ROUTINE[834],SEG    BOTTU      ;208
                MOV     WORD PTR ROUTINE[836],OFFSET BOTTL      ;BOTT 17
                MOV     WORD PTR ROUTINE[838],SEG    BOTTL      ;209
                MOV     WORD PTR ROUTINE[840],OFFSET BOTTINATT  ;BOTT 18
                MOV     WORD PTR ROUTINE[842],SEG    BOTTINATT  ;210
                MOV     WORD PTR ROUTINE[844],OFFSET AUTOON     ;BOTT 19
                MOV     WORD PTR ROUTINE[846],SEG    AUTOON     ;211
                MOV     WORD PTR ROUTINE[848],OFFSET AUTOOFF    ;BOTT 20
                MOV     WORD PTR ROUTINE[850],SEG    AUTOOFF    ;212
                MOV     WORD PTR ROUTINE[852],OFFSET BOTTINATT  ;BOTT 21
                MOV     WORD PTR ROUTINE[854],SEG    BOTTINATT  ;213
                MOV     WORD PTR ROUTINE[856],OFFSET BOTTINATT  ;BOTT 22
                MOV     WORD PTR ROUTINE[858],SEG    BOTTINATT  ;214
                MOV     WORD PTR ROUTINE[860],OFFSET BOTTINATT  ;BOTT 23
                MOV     WORD PTR ROUTINE[862],SEG    BOTTINATT  ;215
                MOV     WORD PTR ROUTINE[864],OFFSET BOTTINATT  ;BOTT 24
                MOV     WORD PTR ROUTINE[866],SEG    BOTTINATT  ;216
 
                MOV     WORD PTR ROUTINE[1016],OFFSET NULL      ;254
                MOV     WORD PTR ROUTINE[1018],SEG    NULL
                MOV     WORD PTR ROUTINE[1020],OFFSET ESCIMAIN  ;255
                MOV     WORD PTR ROUTINE[1022],SEG    ESCIMAIN
 
;CARICA IN MEMORIA GLI OFFSET DEI TIPI VARIABILE
                MOV     WORD PTR ADDRTIPOVAR[0], OFFSET TIPOVAR1
                MOV     WORD PTR ADDRTIPOVAR[2], OFFSET TIPOVAR2
                MOV     WORD PTR ADDRTIPOVAR[4], OFFSET TIPOVAR3
                MOV     WORD PTR ADDRTIPOVAR[6], OFFSET TIPOVAR4
                MOV     WORD PTR ADDRTIPOVAR[8], OFFSET TIPOVAR5
                MOV     WORD PTR ADDRTIPOVAR[10], OFFSET TIPOVAR6
                MOV     WORD PTR ADDRTIPOVAR[12], OFFSET TIPOVAR7
                MOV     WORD PTR ADDRTIPOVAR[14], OFFSET TIPOVAR8
                MOV     WORD PTR ADDRTIPOVAR[16], OFFSET TIPOVAR9
                MOV     WORD PTR ADDRTIPOVAR[18], OFFSET TIPOVAR10
                MOV     WORD PTR ADDRTIPOVAR[20], OFFSET TIPOVAR11
                MOV     WORD PTR ADDRTIPOVAR[22], OFFSET TIPOVAR12
                MOV     WORD PTR ADDRTIPOVAR[24], OFFSET TIPOVAR13
                MOV     WORD PTR ADDRTIPOVAR[26], OFFSET TIPOVAR14
                MOV     WORD PTR ADDRTIPOVAR[28], OFFSET TIPOVAR15
                MOV     WORD PTR ADDRTIPOVAR[30], OFFSET TIPOVAR16
                MOV     WORD PTR ADDRTIPOVAR[32], OFFSET TIPOVAR17
                MOV     WORD PTR ADDRTIPOVAR[34], OFFSET TIPOVAR18
                MOV     WORD PTR ADDRTIPOVAR[36], OFFSET TIPOVAR19
                MOV     WORD PTR ADDRTIPOVAR[38], OFFSET TIPOVAR20
                MOV     WORD PTR ADDRTIPOVAR[40], OFFSET TIPOVAR21
                MOV     WORD PTR ADDRTIPOVAR[42], OFFSET TIPOVAR22
                MOV     WORD PTR ADDRTIPOVAR[44], OFFSET TIPOVAR23
                MOV     WORD PTR ADDRTIPOVAR[46], OFFSET TIPOVAR24
                MOV     WORD PTR ADDRTIPOVAR[48], OFFSET TIPOVAR25
                MOV     WORD PTR ADDRTIPOVAR[50], OFFSET TIPOVAR26
                MOV     WORD PTR ADDRTIPOVAR[52], OFFSET TIPOVAR27
                MOV     WORD PTR ADDRTIPOVAR[54], OFFSET TIPOVAR28
                MOV     WORD PTR ADDRTIPOVAR[56], OFFSET TIPOVAR29
                MOV     WORD PTR ADDRTIPOVAR[58], OFFSET TIPOVAR30
 
MAINLOOP:       MOV     AH,0BH                  ;CONTROLLA SE
                INT     21H                     ; CARATTERE PRONTO
                CMP     AL,0                    ;   O C-BREAK
                JZ      NOTASTO
                MOV     SI,ROUTINETA
                SHL     SI,1
                SHL     SI,1
                CALL    DWORD   PTR     ROUTINE[SI]
NOTASTO:        MOV     DX,STATPORT             ;STATO MPU DATA SET READY
                IN      AL,DX                   ;SE BIT 8 = 0 LA MPU
                ROL     AL,1                    ;   NON HA DATI PRONTI
                JB      NORECEIVE               ;===NULLA DA RICEVERE===
                MOV     SI,ROUTINERC            ;BIT 8 = 1 LEGGI DATI
                SHL     SI,1                    ;  CON LA ROUTINERC
                SHL     SI,1
                CALL    DWORD   PTR     ROUTINE[SI]
NORECEIVE:      MOV     DX,STATPORT             ;STATO MPU DATA RECEIVE READY
                IN      AL,DX                   ;SE BIT 7 = 0 LA MPU
                TEST    AL,DRR                  ;   NON E' PRONTA A RICEVERE
                JNZ     NOTRASMIT               ;DATI; NON TRASMETTERE !
                MOV     SI,ROUTINETR            ;BIT 7 = 1 MPU ACCETTA
                SHL     SI,1                    ;TRASMISSINE DA ROUTINETR
                SHL     SI,1
                CALL    DWORD   PTR     ROUTINE[SI]
NOTRASMIT:      MOV     SI,ROUTINESP            ;SPARE ROUTINE
                SHL     SI,1                    ; QUI ROUTINE
                SHL     SI,1                    ;   IN CODA
                CALL    DWORD   PTR     ROUTINE[SI]
                MOV     SI,ROUTINEFI            ;FILE ROUTINE
                SHL     SI,1
                SHL     SI,1
                CALL    DWORD   PTR     ROUTINE[SI]
                MOV     SI,ROUTINECO            ;CONTROL ROUTINE
                SHL     SI,1
                SHL     SI,1
                CALL    DWORD   PTR     ROUTINE[SI]
                INC     TIMECO          ;CONTA I CICLI DI MAIN LOOP FATTI
                INC     TIMESP          ;CONTA I CICLI DI MAIN LOOP FATTI
                CMP     TIMESP,10000
                JB      NOTIMEOUTSP
                MOV     STATUSSP,0EEH
                MOV     TIMESP,0
NOTIMEOUTSP:    JMP     MAINLOOP
                RET                             ;QUI NON SI ARRRIVA MAI
MAIN            ENDP                            ;FINE PROGRAMMA
 
CSEG            ENDS
 
STACK           SEGMENT PARA STACK 'STACK'
                DB      640 DUP("STACK   "),     ;2560 WORD STACK AREA
STACK           ENDS
 
END             MAIN
